/*----------------------------------------------------------------------*/
/* %full_filespec:   DateTimeSelector.js~6:js:auth#1 %                  */
/* %date_modified:   Fri Apr 14 10:50:05 2006 %                         */
/* %derived_by:      ggoodwin %                                          */
/*--------------------------------------------------------------------- */
/* Copyright (c) 2002 Novell, Inc.  All rights reserved.                */
/*--------------------------------------------------------------------- */

var weekend = [ 0,6 ];
var weekendColor = "#e0e0e0";
var fontface = "Verdana";
var fontsize = 2;
var showYear = false;
var showTime = false;
var currentTime;

/* Default values are provided for the following constants, but users    */
/* should call the function "setLocalizedStrings()" with appropriate     */
/* values in order to display the calendar in a particular locale.       */

var jan = "January";
var feb = "February";
var mar = "March";
var apr = "April";
var may = "May";
var june = "June";
var july = "July";
var aug = "August";
var sept = "September";
var oct = "October";
var nov = "November";
var dec = "December";

var sun = "Sun";
var mon = "Mon";
var tue = "Tue";
var wed = "Wed";
var thu = "Thu";
var fri = "Fri";
var sat = "Sat";

var time = "Time:";

var incYearTip = "Increment year";
var incMonthTip = "Increment month";
var incHourTip = "Increment hour";
var incMinuteTip = "Increment minute";
var decYearTip = "Decrement year";
var decMonthTip = "Decrement month";
var decHourTip = "Decrement hour";
var decMinuteTip = "Decrement minute";

var errEffectiveAfterExpire = "You have selected an effective date later than the expiration date.  The effective date has been restored to its previous value.";
var errExpireBeforeEffective = "You have selected an expiration date earlier than the effective date.  The expiration date has been restored to its previous value.";
var errEffectiveBeforeCA = "You have selected an effective date earlier than the signing CA effective date.  The effective date has been set to the signing CA effective date.";
var errExpireAfterCA = "You have selected an expiration date later than the signing CA expiration date.  The expiration date has been set to the signing CA expiration date.";

var imageBaseDir = "";
var javaScriptDir = "";

var gNow = new Date();
var gblCalWindow;
var gblCal;

/* Set Calender  */
var months =
[
	jan, feb, mar,
	apr, may, june,
	july, aug, sept,
	oct, nov, dec
];

/* Days in the months for non-leap years..  */
Calendar.DOMonth = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];

/* Days in the months for leap years..  */
Calendar.lDOMonth = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];


/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
function Calendar
(
	p_title,
	p_item,			// text field in which to store the resulting string
	p_WinCal,
	srcDate,
	minDate,			// minimum allowable date
	maxDate,			// maximum allowable date
	whichBoundary	// "upper" - expiration date; "lower" - effective date
)
{
	if ( srcDate == null )
	{
		return;
	}

	if ( p_WinCal == null )
	{
		this.gCalWindow = gblCalWindow;
	}
	else
	{
		this.gCalWindow = p_WinCal;
	}

	this.gTitle				= p_title;
	this.gSrcDate			= new Date( srcDate.getTime() );
	this.gMinDate			= new Date( minDate.getTime() );
	this.gMaxDate			= new Date( maxDate.getTime() );
	this.gWhichBoundary	= whichBoundary;
	this.gBGColor			= "white";
	this.gFGColor			= "black";
	this.gTextColor		= "black";
	this.gHeaderColor		= "black";
	this.gReturnItem		= p_item;
}

Calendar.get_month = Calendar_get_month;
Calendar.get_daysofmonth = Calendar_get_daysofmonth;
Calendar.calc_month_year = Calendar_calc_month_year;

/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
function Calendar_get_month( monthNo )
{
	return months[ monthNo ];
}

/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
function Calendar_get_daysofmonth( monthNo, p_year )
{
	// Start by assuming a normal (non-leap) year.

	var rVal = Calendar.DOMonth[  monthNo ];

	// Rules for calculating leap years:
	//  1. Years evenly divisible by four are leap years
	//  2. Years also evenly divisible by 100 are not leap years
	//  3. Years also evenly divisible by 400 are leap years.

	if ( ( p_year % 4 ) == 0 )
	{
		rVal = Calendar.lDOMonth[ monthNo ];
		if ( ( p_year % 100 ) == 0 )
		{
			rVal = Calendar.DOMonth[ monthNo ];
			if ( ( p_year % 400 ) == 0 )
			{
				rVal = Calendar.lDOMonth[ monthNo ];
			}
		}
	}
	return( rVal );
}

/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
function Calendar_calc_month_year( p_Month, p_Year, incr )
{
	// Will return an 1-D array with 1st element being the calculated month
	// and second being the calculated year after applying the month
	// increment/decrement as specified by 'incr' parameter.  'incr' will
	// normally have 1/-1 to navigate thru the months.

	var ret_arr = new Array();
	if ( incr == -1 )
	{
		/*  Go Backwards  */
		if ( p_Month == 0 )
		{
			ret_arr[ 0 ] = 11;
			if ( showYear )
			{
			   ret_arr[ 1 ] = parseInt( p_Year ) - 1;
			}
			else
			{
			   ret_arr[ 1 ] = parseInt( p_Year );
			}
		}
		else
		{
			ret_arr[ 0 ] = parseInt( p_Month ) - 1;
			ret_arr[ 1 ] = parseInt( p_Year );
		}
	}
	else if ( incr == 1 )
	{
		/*  Go Forward  */
		if ( p_Month == 11 )
		{
			ret_arr[ 0 ] = 0;
			if ( showYear )
			{
			   ret_arr[ 1 ] = parseInt( p_Year ) + 1;
			}
			else
			{
			   ret_arr[ 1 ] = parseInt( p_Year );
			}
		}
		else
		{
			ret_arr[ 0 ] = parseInt(p_Month) + 1;
			ret_arr[ 1 ] = parseInt(p_Year);
		}
	}

	return ret_arr;
}

/*----------------------------------------------------------------------*/
/* Prototype object creation and deletion for compatibility w/Navigator 3  */
/*----------------------------------------------------------------------*/
new Calendar();


/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
Calendar.prototype.getMonthlyCalendarCode = function()
{
	var vCode = "";
	var vHeader_Code = "";
	var vData_Code = "";

	/*  Begin Table Drawing code here..  */
	vCode = vCode + "<TABLE BORDER=1 BGCOLOR=\"" + this.gBGColor + "\">";

	vHeader_Code = this.cal_header();
	vData_Code = this.cal_data();
	vCode = vCode + vHeader_Code + vData_Code;

	vCode = vCode + "</TABLE>";

	return vCode;
}

/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
Calendar.prototype.show = function( )
{
	var vCode = "";

	this.gCalWindow.document.open();

	/*  Setup the page...  */
	this.wwrite("<HTML>");
	this.wwrite("<head><title>" + this.gTitle + "</title>");

	this.wwrite("<script language=\"JavaScript\">");

	if ( showTime )
	{
		this.wwrite( "\tvar dtsGblDate;" );

		/* The function that increments the hour displayed.                  */
		this.wwrite("function tsUpHour( dstTF, dateObj )");
		this.wwrite("{");
		this.wwrite("\tvar hour = dateObj.getHours();");
		this.wwrite("\tvar minute = dateObj.getMinutes();");
		this.wwrite("\thour = hour + 1;");
		this.wwrite("\tif ( hour > 23 )");
		this.wwrite("\t{");
		this.wwrite("\t\thour = 0;");
		this.wwrite("\t}");
		this.wwrite("\ttsSetTime( dstTF, hour, minute, dateObj );");
		this.wwrite("}");

		/* The function that increments the minute displayed.                */
		this.wwrite("function tsUpMinute( dstTF, dateObj )");
		this.wwrite("{");
		this.wwrite("\tvar hour = dateObj.getHours();");
		this.wwrite("\tvar minute = dateObj.getMinutes();");
		this.wwrite("\tminute = minute + 1;");
		this.wwrite("\tif ( minute > 59 )");
		this.wwrite("\t{");
		this.wwrite("\t\tminute = 0;");
		this.wwrite("\t}");
		this.wwrite("\ttsSetTime( dstTF, hour, minute, dateObj );");
		this.wwrite("}");

		/* The function that decrements the hour displayed.                  */
		this.wwrite("function tsDownHour( dstTF, dateObj )");
		this.wwrite("{");
		this.wwrite("\tvar hour = dateObj.getHours();");
		this.wwrite("\tvar minute = dateObj.getMinutes();");
		this.wwrite("\thour = hour - 1;");
		this.wwrite("\tif ( hour < 0 )");
		this.wwrite("\t{");
		this.wwrite("\t\thour = 23;");
		this.wwrite("\t}");
		this.wwrite("\ttsSetTime( dstTF, hour, minute, dateObj );");
		this.wwrite("}");

		/* The function that decrements the minute displayed.                */
		this.wwrite("function tsDownMinute( dstTF, dateObj )");
		this.wwrite("{");
		this.wwrite("\tvar hour = dateObj.getHours();");
		this.wwrite("\tvar minute = dateObj.getMinutes();");
		this.wwrite("\tminute = minute - 1;");
		this.wwrite("\tif ( minute < 0 )");
		this.wwrite("\t{");
		this.wwrite("\t\tminute = 59;");
		this.wwrite("\t}");
		this.wwrite("\ttsSetTime( dstTF, hour, minute, dateObj );");
		this.wwrite("}");

		/* The function that displays the time.                              */
		this.wwrite("function tsSetTime( dstTF, hour, minute, dateObj )");
		this.wwrite("{");
		this.wwrite("\tdateObj.setHours( hour );");
		this.wwrite("\tdateObj.setMinutes( minute );");
		this.wwrite("\tif ( dstTF.disabled )");
		this.wwrite("\t{");
		this.wwrite("\t\treturn;");
		this.wwrite("\t}");
		this.wwrite("\tvar suffix;");
		this.wwrite("\tif ( dateObj.getHours() < 12 )");
		this.wwrite("\t{");
		this.wwrite("\tsuffix = \"AM\";");
		this.wwrite("\t}");
		this.wwrite("\telse");
		this.wwrite("\t{");
		this.wwrite("\tsuffix = \"PM\";");
		this.wwrite("\t}");
		this.wwrite("\tvar hour_12_display = \"\";");
		this.wwrite("\tvar hour_12 = dateObj.getHours();");
		this.wwrite("\tif ( hour_12 > 12 )");
		this.wwrite("\t{");
		this.wwrite("\t\thour_12 = hour_12 - 12;");
		this.wwrite("\t}");
		this.wwrite("\telse if ( hour_12 == 0 )");
		this.wwrite("\t{");
		this.wwrite("\t\thour_12 = 12");
		this.wwrite("\t}");
		this.wwrite("\thour_12_display = hour_12.toString();");
		this.wwrite("\tvar hour_24_display = \"\";");
		this.wwrite("\tif ( dateObj.getHours() < 10 )");
		this.wwrite("\t{");
		this.wwrite("\t\thour_24_display = \"0\" + dateObj.getHours().toString();");
		this.wwrite("\t}");
		this.wwrite("\telse");
		this.wwrite("\t{");
		this.wwrite("\t\thour_24_display = dateObj.getHours().toString();");
		this.wwrite("\t}");
		this.wwrite("\tvar minute_display = \"\";");
		this.wwrite("\tif ( dateObj.getMinutes() < 10 )");
		this.wwrite("\t{");
		this.wwrite("\t\tminute_display = \"0\" + dateObj.getMinutes().toString();");
		this.wwrite("\t}");
		this.wwrite("\telse");
		this.wwrite("\t{");
		this.wwrite("\t\tminute_display = dateObj.getMinutes().toString();");
		this.wwrite("\t}");
		this.wwrite("\tdstTF.value = \" \" + hour_24_display + \":\" + minute_display + \"  (\" +");
		this.wwrite("\t\t\t\t\t\thour_12_display + \":\" + minute_display + \" \" +");
		this.wwrite("\t\t\t\t\t\tsuffix + \")\";");
		this.wwrite("\tsetDirty();");
		this.wwrite("}");

		// Write the method that initializes the time field.
		this.wwrite
		(
			"\tfunction initDTS() {"
		);
		this.wwrite
		(
			"\t\tdtsGblDate=new Date(Number('" + this.gSrcDate.getTime().toString() + "'));"
		);
		this.wwrite( "\t\tdtsGblDate.setSeconds( 0 );" );
		this.wwrite
		(
			"\t\ttsSetTime( document.DTS_TimeForm.timeTF, dtsGblDate.getHours(), dtsGblDate.getMinutes(), dtsGblDate);"
		);
		this.wwrite("\t} //end of function initDTS()\n");
	}

	// Write the method that calls the parent window's Build() method.
	this.wwrite("\n\tfunction callBuilder( newDate, minDate, maxDate ) { ");
	this.wwrite("\t\tnewDate.setHours(dtsGblDate.getHours());");
	this.wwrite("\t\tnewDate.setMinutes(dtsGblDate.getMinutes());");
	this.wwrite("\t\tnewDate.setSeconds(dtsGblDate.getSeconds());");
	this.wwrite
	(
		"\t\tself.opener.Build('" + toScript( this.gTitle ) + "'," +
		"'" + this.gReturnItem + "'," +
		"newDate," +
		"minDate," +
		"maxDate," +
		"'" + this.gWhichBoundary + "');"
	);
	this.wwrite("\t} //end of function callBuilder()\n");

	// write the method that checks the new date against the min and max.
	this.wwrite("\n\tfunction CheckDate( checkMe ) { ");
	this.wwrite("\t	var returnValue = 0;");
	this.wwrite("\t	if( checkMe.getTime() < " + this.gMinDate.getTime() + ")");
	this.wwrite("\t	{");
	this.wwrite("\t		returnValue = -1;");
	this.wwrite("\t	}");
	this.wwrite("\t	if( checkMe.getTime() > " + this.gMaxDate.getTime() + " )");
	this.wwrite("\t	{");
	this.wwrite("\t		returnValue = 1;");
	this.wwrite("\t	}");
	this.wwrite("\t   return returnValue;");
	this.wwrite("\t} //end of function CheckDate()\n");

	// Write the method that sends the new date data to the parent window.
	this.wwrite("function done( curDate, selectedDay ){");
	this.wwrite("var tgtDate = new Date( curDate.getTime() );");
	this.wwrite("tgtDate.setDate( selectedDay );");

	if ( showTime )
	{
	   this.wwrite("tgtDate.setHours( dtsGblDate.getHours() );");
	   this.wwrite("tgtDate.setMinutes( dtsGblDate.getMinutes() );");
	   this.wwrite("tgtDate.setSeconds( dtsGblDate.getSeconds() );");
	}

	this.wwrite("var rValue = CheckDate( tgtDate );");
	this.wwrite("switch ( rValue )");
	this.wwrite("{");
	this.wwrite("\tcase -1:");
	if ( "upper" == this.gWhichBoundary )	// we're checking expiration
	{
		this.wwrite("\t		alert( '" + toScript(errExpireBeforeEffective) + "' );");
		this.wwrite("\t		tgtDate.setTime(Number('" + this.gSrcDate.getTime().toString() + "'));");
	}
	else if ( "lower" == this.gWhichBoundary ) // we're checking effective
	{
		this.wwrite("\t		alert( '" + toScript(errEffectiveBeforeCA) + "' );");
		this.wwrite("\t		tgtDate.setTime(Number('" + this.gMinDate.getTime().toString() + "'));");
	}

	this.wwrite("\t\tbreak;");
	this.wwrite("\tcase 0:");
	this.wwrite("\t\tbreak;");
	this.wwrite("\tcase 1:");
	if ( "upper" == this.gWhichBoundary )	// we're checking expiration
	{
		this.wwrite("\t		alert( '" + toScript(errExpireAfterCA) + "' );");
		this.wwrite("\t		tgtDate.setTime(Number('" + this.gMaxDate.getTime().toString() + "'));");
	}
	else if ( "lower" == this.gWhichBoundary ) // we're checking effective
	{
		this.wwrite("\t		alert( '" + toScript(errEffectiveAfterExpire) + "' );");
		this.wwrite("\t		tgtDate.setTime(Number('" + this.gSrcDate.getTime().toString() + "'));");
	}
	this.wwrite("\t\tbreak;");
	this.wwrite("}");

	this.wwrite
	(
		"\tself.opener.document." + this.gReturnItem + ".value = tgtDate.getTime().toString();"
	);
	this.wwrite
	(
		"\tself.opener.pkiUpdateDate('" + this.gWhichBoundary + "');"
	);
	this.wwrite("self.close();");
	this.wwrite("}	// end of function done()");
	this.wwrite("function setDirty(){}");
	this.wwrite("</script>");
	this.wwrite("</head>");

	if ( showTime )
	{
		this.wwrite
		(
			"<body " + "link=\"" + this.gLinkColor + "\" " +
			"vlink=\"" + this.gLinkColor + "\" " +
			"alink=\"" + this.gLinkColor + "\" " +
			"text=\"" + this.gTextColor + "\" " +
			"onload=\"initDTS()\">"
		);
	}
	else
	{
		this.wwrite
		(
			"<body " + "link=\"" + this.gLinkColor + "\" " +
			"vlink=\"" + this.gLinkColor + "\" " +
			"alink=\"" + this.gLinkColor + "\" " +
			"text=\"" + this.gTextColor + "\">"
		);
	}

	this.wwriteA( "<FONT FACE='" + fontface + "' SIZE=2><B>" );
	this.wwriteA( Calendar.get_month( this.gSrcDate.getMonth() ) );

	if ( showYear )
	{
	   this.wwriteA( " " + this.gSrcDate.getFullYear() );
	}

	this.wwriteA("</B><BR>");

	/*  Show navigation buttons  */
	var tmpNewDate = Calendar.calc_month_year
	(
		this.gSrcDate.getMonth(),
		this.gSrcDate.getFullYear(),
		-1
	);
	var prevMonth = new Date( this.gSrcDate.getTime() );
	prevMonth.setMonth( tmpNewDate[ 0 ] );
	prevMonth.setFullYear( tmpNewDate[ 1 ] );

	tmpNewDate = Calendar.calc_month_year
	(
		this.gSrcDate.getMonth(),
		this.gSrcDate.getFullYear(),
		1
	);
	var nextMonth = new Date( this.gSrcDate.getTime() );
	nextMonth.setMonth( tmpNewDate[ 0 ] );
	nextMonth.setFullYear( tmpNewDate[ 1 ] );

	var prevYear = new Date( this.gSrcDate.getTime() );
	prevYear.setFullYear( this.gSrcDate.getFullYear() - 1 );

	var nextYear = new Date( this.gSrcDate.getTime() );
	nextYear.setFullYear( this.gSrcDate.getFullYear() + 1 );

	/*  Write the buttons at the top  */
	this.wwrite
	(
		"<TABLE WIDTH='100%' BORDER=1 CELLSPACING=0 CELLPADDING=0 " +
		"BGCOLOR='#e0e0e0'><TR>"
	);
	if ( showYear )
	{
	   this.wwrite
	   (
	   	"<TD ALIGN=center onClick=\"callBuilder(" +
	   	"new Date(Number('" + prevYear.getTime().toString() + "'))," +
	   	"new Date(Number('" + this.gMinDate.getTime().toString() + "'))," +
			"new Date(Number('" + this.gMaxDate.getTime().toString() + "'))" +
			");\">" +
			"<img alt='" + decYearTip + "' " +
			"src=\"" + imageBaseDir + "DoubleLeftArrow.gif\" " +
			"width=16 height=16 border=0></TD>"
		);
	}
   this.wwrite
   (
   	"<TD ALIGN=center onClick=\"callBuilder(" +
   	"new Date(Number('" + prevMonth.getTime().toString() + "'))," +
   	"new Date(Number('" + this.gMinDate.getTime().toString() + "'))," +
   	"new Date(Number('" + this.gMaxDate.getTime().toString() + "'))" +
		");\">" +
		"<img alt='" + decMonthTip + "' " +
		"src=\"" + imageBaseDir + "LeftArrow.gif\" " +
		"width=16 height=16 border=0></TD>"
	);
   this.wwrite
   (
   	"<TD ALIGN=center onClick=\"callBuilder(" +
   	"new Date(Number('" + nextMonth.getTime().toString() + "'))," +
   	"new Date(Number('" + this.gMinDate.getTime().toString() + "'))," +
   	"new Date(Number('" + this.gMaxDate.getTime().toString() + "'))" +
   	");\">" +
   	"<img alt='" + incMonthTip + "' " +
   	"src=\"" + imageBaseDir + "RightArrow.gif\" " +
   	"width=16 height=16 border=0></TD>"
	);
	if ( showYear )
	{
	   this.wwrite
	   (
	   	"<TD ALIGN=center onClick=\"callBuilder(" +
	   	"new Date(Number('" + nextYear.getTime().toString() + "'))," +
	   	"new Date(Number('" + this.gMinDate.getTime().toString() + "'))," +
	   	"new Date(Number('" + this.gMaxDate.getTime().toString() + "'))" +
	   	");\">" +
	   	"<img alt='" + incYearTip + "' " +
	   	"src=\"" + imageBaseDir + "DoubleRightArrow.gif\" " +
	   	"width=16 height=16 border=0></TD>"
		);
	}
	this.wwrite("</TR></TABLE><BR>");

	/*  Get the complete calendar code for the month..  */
	vCode = this.getMonthlyCalendarCode();
	this.wwrite(vCode);
	this.wwrite("</font>");

	/*  Write the time control if requested  */
	if ( showTime )
	{
        this.wwrite("<form name=\"DTS_TimeForm\" method=post>");
        this.wwrite("<b>" + time + "</b>");
        this.wwrite("<center>");
        this.wwrite("<a href=\"javascript:tsDownHour(document.DTS_TimeForm.timeTF, dtsGblDate);\"><img alt='" + decHourTip + "' src=\"" + imageBaseDir + "DoubleLeftArrow.gif\" width=16 height=16 border=1></a>");
        this.wwrite("<a href=\"javascript:tsDownMinute(document.DTS_TimeForm.timeTF, dtsGblDate);\"><img alt='" + decMinuteTip + "' src=\"" + imageBaseDir + "LeftArrow.gif\" width=16 height=16 border=1></a>");
        this.wwrite("<input type=\"text\" name=\"timeTF\" value=\"\" size=\"15\" readonly>");
        this.wwrite("<a href=\"javascript:tsUpMinute(document.DTS_TimeForm.timeTF, dtsGblDate);\"><img alt='" + incMinuteTip + "' src=\"" + imageBaseDir + "RightArrow.gif\" width=16 height=16 border=1></a>");
        this.wwrite("<a href=\"javascript:tsUpHour(document.DTS_TimeForm.timeTF, dtsGblDate);\"><img alt='" + incHourTip + "' src=\"" + imageBaseDir + "DoubleRightArrow.gif\" width=16 height=16 border=1></a>");
        this.wwrite("</center>");
        this.wwrite("</form>");
	}
	this.wwrite("</body></HTML>");
	this.gCalWindow.document.close();
}


/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
Calendar.prototype.wwrite = function( wtext )
{
	this.gCalWindow.document.writeln( wtext );
}

/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
Calendar.prototype.wwriteA = function( wtext )
{
	this.gCalWindow.document.write( wtext );
}

/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
Calendar.prototype.cal_header = function()
{
	var vCode = "";

	vCode = vCode + "<TR>";
	vCode = vCode + "<TD WIDTH='14%'><FONT SIZE='2' FACE='" + fontface + "' COLOR='" + this.gHeaderColor + "'><B>" + sun + "</B></FONT></TD>";
	vCode = vCode + "<TD WIDTH='14%'><FONT SIZE='2' FACE='" + fontface + "' COLOR='" + this.gHeaderColor + "'><B>" + mon + "</B></FONT></TD>";
	vCode = vCode + "<TD WIDTH='14%'><FONT SIZE='2' FACE='" + fontface + "' COLOR='" + this.gHeaderColor + "'><B>" + tue + "</B></FONT></TD>";
	vCode = vCode + "<TD WIDTH='14%'><FONT SIZE='2' FACE='" + fontface + "' COLOR='" + this.gHeaderColor + "'><B>" + wed + "</B></FONT></TD>";
	vCode = vCode + "<TD WIDTH='14%'><FONT SIZE='2' FACE='" + fontface + "' COLOR='" + this.gHeaderColor + "'><B>" + thu + "</B></FONT></TD>";
	vCode = vCode + "<TD WIDTH='14%'><FONT SIZE='2' FACE='" + fontface + "' COLOR='" + this.gHeaderColor + "'><B>" + fri + "</B></FONT></TD>";
	vCode = vCode + "<TD WIDTH='16%'><FONT SIZE='2' FACE='" + fontface + "' COLOR='" + this.gHeaderColor + "'><B>" + sat + "</B></FONT></TD>";
	vCode = vCode + "</TR>";

	return vCode;
}

/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
Calendar.prototype.cal_data = function()
{
	/* Create a date object representing the first day of the given month.  */
	var vDate = new Date();
	vDate.setDate( 1 );
	vDate.setMonth( this.gSrcDate.getMonth() );
	vDate.setFullYear( this.gSrcDate.getFullYear() );

	var vFirstDay = vDate.getDay();
	var vDay = 1;
	var vLastDay = Calendar.get_daysofmonth
	(
		this.gSrcDate.getMonth(),
		this.gSrcDate.getFullYear()
	);
	var vOnLastDay = 0;
	var htmlCode = "";

	/* Place as many blank cells before the 1st day of the month as         */
	/* necessary.                                                           */

	htmlCode += "<TR>";
	for ( i = 0; i < vFirstDay; i++ )
	{
		htmlCode +=
		(
			"<TD WIDTH='14%'" + this.write_weekend_string( i ) + ">" +
			"<FONT SIZE='2' FACE='" + fontface + "'> </FONT></TD>"
		);
	}

	/*  Write rest of the 1st week  */
	for ( j = vFirstDay; j < 7; j++ )
	{
		htmlCode +=
		(
			"<TD WIDTH='14%'" + this.write_weekend_string( j ) + ">" +
			"<FONT SIZE='2' FACE='" + fontface + "'>" +
			"<A href=\"javascript:done(new Date(Number('" +
			this.gSrcDate.getTime().toString() + "'))," + vDay + ");\">" +
			this.format_day( vDay ) + "</A>" + "</FONT></TD>"
		);
		vDay = vDay + 1;
	}
	htmlCode += "</TR>";

	/*  Write the rest of the weeks  */
	for ( k = 2; k < 7; k++ )
	{
		htmlCode += "<TR>";
		for ( j = 0; j < 7; j++ )
		{
			htmlCode +=
			(
				"<TD WIDTH='14%'" + this.write_weekend_string( j ) + ">" +
				"<FONT SIZE='2' FACE='" + fontface + "'>" +
				"<A href=\"javascript:done(new Date(Number('" +
				this.gSrcDate.getTime().toString() + "'))," + vDay + ");\">" +
				this.format_day( vDay ) + "</A>" + "</FONT></TD>"
			);
			vDay = vDay + 1;

			if ( vDay > vLastDay )
			{
				vOnLastDay = 1;
				break;
			}
		}

		if ( vOnLastDay == 1 )
		{
			break;
		}
		if ( j != 6 )
		{
			htmlCode += "</TR>";
		}
	}

	/* Fill up the last week with blanks so that we get properly aligned    */
	/* square blocks.                                                       */
	for ( m = 1; m < ( 7 - j ); m++ )
	{
		htmlCode +=
		(
			"<TD WIDTH='14%'" + this.write_weekend_string( j + m ) + ">" +
			"<FONT SIZE='2' FACE='" + fontface + "' COLOR='gray'>" +
			 m +
			 "</FONT></TD>"
		);
	}
	htmlCode += "</TR>";
	return htmlCode;
}

/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
Calendar.prototype.format_day = function( vday )
{
	var vNowDay = gNow.getDate();
	var vNowMonth = gNow.getMonth();
	var vNowYear = gNow.getFullYear();

	if
	(
		( vday == vNowDay ) &&
		( this.gSrcDate.getMonth() == vNowMonth ) &&
		( this.gSrcDate.getFullYear() == vNowYear )
	)
	{
		return("<FONT COLOR=\"RED\"><B>" + vday + "</B></FONT>");
	}
	else
	{
		return( vday );
	}
}

/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
Calendar.prototype.write_weekend_string = function( vday )
{
	var i;

	/* Return special formatting for the weekend day.                       */
	for ( i = 0; i < weekend.length; i++ )
	{
		if ( vday == weekend[ i ] )
		{
			return (" BGCOLOR=\"" + weekendColor + "\"");
		}
	}
	return "";
}

/*----------------------------------------------------------------------*/
// minDate: the minimum allowable date that can be chosen
// maxDate: the maximum allowable date that can be chosen
// whichBoundary: a string "upper" or "lower"; corresponding to choosing
// the effective (lower) or expiration (upper) date.
/*----------------------------------------------------------------------*/
function Build
(
	title,
	targetTF,
	srcDate,
	minDate,
	maxDate,
	whichBoundary
)
{
	gblCal = new Calendar
	(
		title,
		targetTF,
		gblCalWindow,
		srcDate,
		minDate,
		maxDate,
		whichBoundary
	);

	/*  Customize your Calendar here..  */
	gblCal.gBGColor="white";
	gblCal.gLinkColor="black";
	gblCal.gTextColor="black";
	gblCal.gHeaderColor="darkblue";

	/*  Choose appropriate show function  */
	gblCal.show( );
}

/*----------------------------------------------------------------------*/
/*  This function is provided solely for localization.  If you dont call   */
/*  this method then all strings will appear in English.                   */
/*----------------------------------------------------------------------*/
function setLocalizedStrings
(
	jan, feb, mar, apr, may, june, july, aug, sept, oct, nov, dec,
	sunAbr, monAbr, tueAbr, wedAbr, thuAbr, friAbr, satAbr,
	timeStr, decYearStr, decMonthStr, decHourStr, decMinuteStr,
	incYearStr, incMonthStr, incHourStr, incMinuteStr,
	effTooEarly, effTooLate, expTooEarly, expTooLate
)
{
   months = [jan, feb, mar, apr, may, june, july, aug, sept, oct, nov, dec];
   sun = sunAbr;
   mon = monAbr;
   tue = tueAbr;
   wed = wedAbr;
   thu = thuAbr;
   fri = friAbr;
   sat = satAbr;
   time = timeStr;
	decYearTip = decYearStr;
	decMonthTip = decMonthStr;
	decHourTip = decHourStr;
	decMinuteTip = decMinuteStr;
	incYearTip = incYearStr;
	incMonthTip = incMonthStr;
	incHourTip = incHourStr;
	incMinuteTip = incMinuteStr;
	errEffectiveBeforeCA = effTooEarly;
	errEffectiveAfterExpire = effTooLate;
	errExpireBeforeEffective = expTooEarly;
	errExpireAfterCA = expTooLate;
}

/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
function setImageBaseDir( dir )
{
   imageBaseDir = dir;
}

/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
function setJavaScriptDir( dir )
{
   javaScriptDir = dir;
}

/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
function show_calendar
(
	title,
	targetTF,
	srcDate,
	shouldShowYear,
	shouldShowTime,
	minDate,
	maxDate,
	whichBoundary
)
{
	showYear = shouldShowYear;
	showTime = shouldShowTime;
	currentTime = time;
	if ( srcDate == null )
	{
		srcDate = new Date();
	}

	if ( showTime )
	{
		gblCalWindow = window.open
		(
			'',
			'',
			'width=300,height=290,status=yes,resizable=yes,top=200,left=200'
		);
	}
	else
	{
		gblCalWindow = window.open
		(
			'',
			'',
			'width=300,height=250,status=yes,resizable=yes,top=200,left=200'
		);
	}
	gblCalWindow.opener = self;
	Build
	(
		title,
		targetTF,
		srcDate,
		minDate,
		maxDate,
		whichBoundary
	);
	return gblCalWindow;
}
