<%
  /*------------------------------------------------------------------------ */
  /* %full_filespec:    PropertyPage_Certificates.jsp~9:ascii:iman_plg#1 %            */
  /* %derived_by:      ggoodwin %                                            */
  /* %date_modified:   Tue Oct 24 15:28:41 2006 %                            */
  /*------------------------------------------------------------------------ */
  /* Copyright (c) 2002 Novell, Inc.  All rights reserved.                   */
  /*------------------------------------------------------------------------ */
  /* This page expects to receive the following variables:                   */
  /*      PKI.ViewUserCertificates.Action                                    */
  /*                                                                         */
  /* This page sends the following variables to the servlet:                 */
  /*                                                                         */
  /*                                                                         */
  /* The purpose of this page is to either browse for a user to run the      */
  /* user certificate list property book or simply to set the target for the */
  /* property book using the user DN passed in                               */
  /*------------------------------------------------------------------------ */
%>

<%@ page   pageEncoding = "utf-8"                                        %>
<%@ page   contentType  = "text/html;charset=utf-8"                      %>
<%@ page   import       = "com.novell.admin.PKI.util.Table"              %>
<%@ page   import       = "com.novell.admin.PKI.util.constants.UIConst"  %>
<%@ page   import       = "com.novell.admin.PKI.constants.ActionID"      %>
<%@ page   import       = "com.novell.admin.PKI.constants.WidgetID"      %>
<%@ page   import       = "com.novell.admin.PKI.constants.Misc"          %>
<%@ page   import       = "com.novell.admin.PKI.util.*"                  %>
<%@ page   import       = "com.novell.admin.PKI.certificate.CertManager" %>
<%@ page   import       = "com.novell.emframe.dev.D"                     %>
<%@ page   import       = "com.novell.admin.PKI.constants.StringID"      %>
<%@ taglib uri          = "/WEB-INF/iman.tld"            prefix = "iman" %>
<%@ taglib uri          = "/WEB-INF/c.tld"               prefix = "c"    %>
<%@ taglib uri          = "/WEB-INF/pki.tld"             prefix = "pki"  %>

<iman:stringtable bundle = "<%= Misc.RESOURCE_BUNDLE_DEV %>"/>
<iman:stringtable bundle = "<%= Misc.RESOURCE_BUNDLE_PKI %>"/>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<%
   try
   {
      Table       tableData;
      CertManager certManager;
      boolean     legacyPropPage;
      HttpRequest httpRequest = new HttpRequest( request );
      boolean     allowRevocation;
      boolean     allowReplace;

      certManager     = (CertManager)httpRequest.getAttribute( WidgetID.CERTIFICATE_MANAGER );
      tableData       = (Table)httpRequest.getAttribute( WidgetID.TABLE_DATA );
      legacyPropPage  = httpRequest.getAttributeAsBoolean( WidgetID.IS_IN_OLD_STYLE_PROPERTY_BOOK );
      allowRevocation = httpRequest.getAttributeAsBoolean( WidgetID.ALLOW_REVOCATION, true );
      allowReplace    = httpRequest.getAttributeAsBoolean( WidgetID.ALLOW_REPLACE,    true );

%>
<html>
   <head>
      <title>
         <iman:string key = "<%= StringID.PAGE_CERTIFICATES_TITLE %>" />
      </title>

      <pki:stylesheet  />
      <iman:stylesheet />

      <iman:include page = "PKI/CertificateInfo_js.jsp" />

      <iman:eMFrameScripts />
      <pki:dataTableScripts />
      <iman:pageScripts />

      <pki:treeScripts      />
      <pki:utilScripts      />

      <script type = "text/javascript" language = "JavaScript" >
         <!--
         function handleOnLoad()
         {
            utilPositionFooterDiv('headerDiv','bodyDiv','footerDiv');
<%
      if ( !legacyPropPage )
      {
%>
            utilSetFooterButtons( window.applyButton | window.okButton | window.cancelButton );
<%
      }
%>
         }
         <%/* end handleOnLoad()  */%>

         function updateDNListandSubmit(
            selectedIndices,
            tableData,
            actionValue )
         {
            var dnArray = new Array();

            for( var i = 0; i < selectedIndices.length; i++ )
            {
               dnArray[ dnArray.length ] = selectedIndices[ i ];
            }

            utilSetElementValue(
               "<%= UIConst.PARAM_TASK_ACTION %>",
               actionValue );

            utilSetElementValue(
               "<%= UIConst.PARAM_DN_LIST %>",
               pack( dnArray ));

            utilSubmitDocumentForm( true );
         }

         function osCallback( osControl, osResults )
         {
            utilSetElementValue(
               "<%= UIConst.PARAM_TASK_ACTION %>",
               "<%= ActionID.ACTION_SET_TARGET %>" );

            utilSetElementValue(
               "<%= UIConst.PARAM_TASK_PARAM %>",
               osResults[ 0 ] );

            utilSubmitDocumentForm( false );
         }
         //-->
      </script>
   </head>

   <body
      onload   = "handleOnLoad()"
      onResize = "utilPositionFooterDiv('headerDiv','bodyDiv','footerDiv')"
      style    = "overflow: hidden" >

      <form
         name   = "MainForm"
         method = "post"
         action = "<c:out value = "${ContextPath}"/>/servlet/frameservice" >

         <pki:frameVars />
         <pki:pageHeader inLegacyPropertyBook = "<%= legacyPropPage %>" >

            <input
               type  = "hidden"
               name  = "eDir$target"
               id    = "eDir$target"
               value = "" />

            <%/* Create a hidden control to hold the value that the server-side code  */
              /* will use to determine whether or not to reread the user certificate info.  */%>
            <input
               type  = "hidden"
               name  = "<%= WidgetID.DATA_REFRESH %>"
               id    = "<%= WidgetID.DATA_REFRESH %>"
               value = "false" />

            <pki:dataTable
               id                = "certificateTable"
               sourceData        = "<%= tableData %>"
               linkActionHandler = "handleLink"
               menuActionHandler = "handleMenu" >

               <pki:menuItem textKey = "<%= StringID.MENU_EXPORT  %>" id = "<%= ActionID.ACTION_EXPORT  %>"  disabled = "<%= 0 == tableData.getNumberOfRows() %>" />
<%
   if ( allowReplace )
   {
%>
               <pki:menuItem textKey = "<%= StringID.MENU_REPLACE %>" id = "<%= ActionID.ACTION_REPLACE %>" disabled = "<%= 0 == tableData.getNumberOfRows() %>" />
<%
   }
   
   if ( certManager.cmmSupportsRevocation() && allowRevocation )
   {
%>
               <pki:menuItem textKey = "<%= StringID.MENU_REVOKE %>"  id = "<%= ActionID.ACTION_REVOKE %>" disabled = "<%= 0 == tableData.getNumberOfRows() %>" />
<%
   }
%>
<%
   if ( certManager.cmmSupportsValidation() )
   {
%>
               <pki:menuItem textKey = "<%= StringID.MENU_VALIDATE %>"  id = "<%= ActionID.ACTION_VALIDATE %>" disabled = "<%= 0 == tableData.getNumberOfRows() %>" />
<%
   }
%>
            </pki:dataTable>

         </pki:pageHeader >

         <table>
            <tr>
               <td valign = "" ></td>
            </tr>
         </table>

      </form>

   </body>
</html>
<%
   }
   catch ( Exception e )
   {
      D.log( e );
%>
      Exception occured processing PropertyPage_Certificates.jsp
<%
   }
%>
