<%

  /*------------------------------------------------------------------------ */
  /* %full_filespec:   WizardPage_CreateCert_Key_js.jsp~idc_nmas#21:ascii:iman_plg#1 %                */
  /* %date_modified:   Wed Apr 18 09:40:24 2007 %                            */
  /* %derived_by:      sanay %                                             */
  /*------------------------------------------------------------------------ */
  /* Copyright (c) 2002 Novell, Inc.  All rights reserved.                   */
  /*------------------------------------------------------------------------ */
  /* This file contains JavaScript specific to the Key page in the Create    */
  /* Certificate Wizard.                                                     */
  /*------------------------------------------------------------------------ */
%>

<%@ page   pageEncoding = "utf-8"                                        %>
<%@ page   contentType  = "text/html;charset=utf-8"                      %>
<%@ page   import       = "com.novell.emframe.dev.D"                     %>
<%@ page   import       = "java.util.List"                               %>
<%@ page   import       = "com.novell.admin.PKI.constants.WidgetID"      %>
<%@ page   import       = "com.novell.admin.PKI.constants.Misc"          %>
<%@ page   import       = "com.novell.admin.PKI.certificate.CertInfo"    %>
<%@ page   import       = "com.novell.admin.PKI.certificate.CertManager" %>
<%@ page   import       = "com.novell.admin.PKI.util.constants.UIConst"  %>
<%@ page   import       = "com.novell.admin.PKI.util.HttpRequest"        %>
<%@ page   import       = "com.novell.admin.PKI.constants.StringID"      %>
<%@ taglib uri          = "/WEB-INF/iman.tld"            prefix = "iman" %>
<%@ taglib uri          = "/WEB-INF/c.tld"               prefix = "c"    %>
<%
   try
   {
      CertInfo    certInfo;
      CertManager certManager;
      HttpRequest httpRequest;

      httpRequest = new HttpRequest( request );

      certInfo    = (CertInfo   )httpRequest.getAttribute( WidgetID.CERTIFICATE_INFO    );
      certManager = (CertManager)httpRequest.getAttribute( WidgetID.CERTIFICATE_MANAGER );
%>

<%
  /* Depending on which "Type" radio button is selected, check the appropriate  */
  /* checkboxes that correspond to the "Type".  */

  /* DO NOT SHOW KEY TYPE IF EXTERNAL: CSR  */
   if ( certInfo.isSigningCAExternal() )
   {
%>
      function checkCheckboxes() { }
      function enableDisableControls() { }
      function dancePage() { }
<%
   }
   else
   {
%>
   function checkCheckboxes()
   {
      var   keyType;

      keyType = utilGetSelectedRadioButton( "<%= WidgetID.KEY_TYPE %>" ).value;

      <%/* Check the appropriate checkboxes depending on the keyType  */%>

      if ( keyType == '<%= Misc.KEY_TYPE_UNSPECIFIED %>' )
      {
         <%/* Nothing to check  */%>
      }
      else if ( keyType == '<%= Misc.KEY_TYPE_ENCRYPTION %>' )
      {
         <%/* Check the "Key encipherment" checkbox.  */%>
         utilSetElementChecked( "<%= WidgetID.KEY_USAGE_KEY %>", true );
      }
      else if ( keyType == '<%= Misc.KEY_TYPE_SIGNATURE %>' )
      {
         utilSetElementChecked( "<%= WidgetID.KEY_USAGE_DIGITAL %>", true );
      }
      else if ( keyType == '<%= Misc.KEY_TYPE_SSL_TLS %>' )
      {
         <%/* Check the "Key encipherment" and "Digital Signature" checkboxes.  */%>
         utilSetElementChecked( "<%= WidgetID.KEY_USAGE_KEY          %>", true );
         utilSetElementChecked( "<%= WidgetID.KEY_USAGE_DIGITAL      %>", true );
      }
      else if ( keyType == '<%= Misc.KEY_TYPE_CERTIFICATE_AUTHORITY %>' )
      {
         <%/* Check the "Certificate Signing" and "CRL Signing" checkboxes.  */%>
         utilSetElementChecked( "<%= WidgetID.KEY_USAGE_CERT_SIGNING %>", true );
         utilSetElementChecked( "<%= WidgetID.KEY_USAGE_CRL_SIGNING  %>", true );
      }
      else if ( keyType == '<%= Misc.KEY_TYPE_CUSTOM %>' )
      {
         <%/* Nothing to do.  */%>
      }
      else
      {
         return;
      }
   }<%/* end checkCheckboxes()  */

     /* Depending on which "Type" radio button is selected, enable/disable controls on the page  */
     /* and check/uncheck certain checkboxes.  */%>
   function dancePage( onlyIfNotCustom )
   {
      var radioBtn = utilGetSelectedRadioButton( '<%= WidgetID.KEY_TYPE %>' );
      var keyType  = radioBtn.value;

      if ( !onlyIfNotCustom || keyType != '<%= Misc.KEY_TYPE_CUSTOM %>' )
      {
         <%/* Enable or disable controls on the page.  */%>
         enableDisableControls();

         <%/* Uncheck the checkboxes.  */%>
         uncheckCheckboxes();

         <%/* Check the appropriate checkboxes depending on which "Type" radio button is selected.  */%>
         checkCheckboxes();
      }
   }<%/* end dancePage()  */%>

<%     /* Depending on which "Type" radio button is selected, enable/disable controls on the page  */%>
   function enableDisableControls()
   {
      var radioBtn;
      var keyType;

      radioBtn = utilGetSelectedRadioButton( "<%= WidgetID.KEY_TYPE %>" );

      if ( radioBtn == null )
      {
         return;
      }

      keyType = radioBtn.value;

      if ( keyType == '<%= Misc.KEY_TYPE_CUSTOM %>' )
      {
         <%/* Enable all the "Key usage" checkboxes.  */%>
         utilEnableControl( "<%= WidgetID.KEY_USAGE_DATA    %>", true );
         utilEnableControl( "<%= WidgetID.KEY_USAGE_KEY     %>", true );
         utilEnableControl( "<%= WidgetID.KEY_USAGE_DIGITAL %>", true );

<%
         /* Enable checkboxes that only exist if we are dealing with a CA.  */
//      if ( certInfo.isCertificateAuthority() || certInfo.isCertificateIssueRequest() )
//      {
%>
         utilEnableControl( "<%= WidgetID.KEY_USAGE_CERT_SIGNING %>", true );
         utilEnableControl( "<%= WidgetID.KEY_USAGE_CRL_SIGNING  %>", true );
<%
//      }
%>
<%
         /* Enable the "Extension" checkbox.  */
%>
         utilEnableControl( "<%= WidgetID.KEY_USAGE_EXTENSION %>", true );
      }
      else
      {
<%
         /* Disable all the "Key usage" checkboxes.  */
%>
         utilEnableControl( "<%= WidgetID.KEY_USAGE_DATA    %>", false );
         utilEnableControl( "<%= WidgetID.KEY_USAGE_KEY     %>", false );
         utilEnableControl( "<%= WidgetID.KEY_USAGE_DIGITAL %>", false );
<%
%>
         utilEnableControl( "<%= WidgetID.KEY_USAGE_CERT_SIGNING %>", false );
         utilEnableControl( "<%= WidgetID.KEY_USAGE_CRL_SIGNING  %>", false );
<%
         /* Enable the "Extension" checkbox.  */
%>
         utilEnableControl( "<%= WidgetID.KEY_USAGE_EXTENSION %>", true );

         if ( keyType == '<%= Misc.KEY_TYPE_UNSPECIFIED %>' )
         {
            <%/* Disable the "Extension" checkbox.  */%>
            utilEnableControl( "<%= WidgetID.KEY_USAGE_EXTENSION %>", false );
         }
         else if ( keyType == '<%= Misc.KEY_TYPE_ENCRYPTION %>' )
         {
            <%/* Nothing to do.  */%>
         }
         else if ( keyType == '<%= Misc.KEY_TYPE_SIGNATURE %>' )
         {
            <%/* Nothing to do.  */%>
         }
         else if ( keyType == '<%= Misc.KEY_TYPE_SSL_TLS %>' )
         {
            <%/* Nothing to do.  */%>
         }
         else if ( keyType == '<%= Misc.KEY_TYPE_CERTIFICATE_AUTHORITY %>' )
         {
            <%/* Nothing to do.  */%>
         }
         else
         {
            return;
         }
      }
   }
<%
      /* end enableDisableControls()  */
   }
%>
   function danceExtendedKeyUsage( onlyIfNotCustom )
   {
<%
      if ( certManager.cmmSupportsExtendedKeyUsage() )
      {
%>
      var radioBtn = utilGetSelectedRadioButton( '<%= WidgetID.EXT_KEY_USAGE_TYPE %>' );
      var keyType  = radioBtn.value;

      if ( !onlyIfNotCustom || keyType != '<%= Misc.EXT_KEY_USAGE_TYPE_CUSTOM %>' )
      {

         enableDisableControls_ExtKeyUsage();
         uncheckCheckBoxes_ExtKeyUsage();
         checkCheckboxes_ExtKeyUsage();
      }
<%
      }
%>
   }

<%
  /* -------------------------------------------  */
  /* Puts the initial input focus into the page.  */
  /* -------------------------------------------  */%>
function onPageLoad()
{
   utilPositionFooterDiv( 'headerDiv','bodyDiv','footerDiv' );
   utilSetFooterButtons ( window.backButton | window.nextButton | window.cancelButton );

   <%/* Dance the page given its initial settings.  */%>
   dancePage( true );
<%
   if ( !certInfo.isSigningCAExternal() && certManager.cmmSupportsExtendedKeyUsage() )
   {
%>
   saveExtCheckBoxValues   ();
   enableDisableExtKeyUsage();
   danceExtendedKeyUsage   ( true );
<%
   }

   if ( !certInfo.isCertificateIssueRequest() )
   {
%>
   onKeySizeChange();
   KeySize_ECDSA();
<%
   }
%>
} <%/* setFocusAndInitializeForm  */%>

function KeySize_RSA()
{
   if (document.getElementById("<%= WidgetID.KEY_ALGO_TYPE_RSA %>").checked == false)
   {
      document.getElementById("<%= WidgetID.KEY_ALGO_TYPE_RSA %>").checked = true;
      alert("RSA Certificate is compulsory");
      return false;
   }
   return true;
}
<%/* KeySizeECDSA() - this function enables/disables the Key size list for EC based on the checkbox  */%>
function KeySize_ECDSA()
{
   if (document.getElementById("<%= WidgetID.KEY_ALGO_TYPE_ECDSA %>").checked == false)
   {
      document.getElementById("<%= WidgetID.KEY_SIZE_ECDSA %>").disabled = true;
   }
   else
   {
      document.getElementById("<%= WidgetID.KEY_SIZE_ECDSA %>").disabled = false;
   }
}
function setDefaultKeysize_EC()
{

            document.getElementById("<%= WidgetID.KEY_SIZE_ECDSA %>").selectedIndex = 1;       <%/* The Default key size is set to 384 if the Algorithm type is ECDSA  */%>

}
<%/* onKeySizeChange() - this function displays the Hint about the Key size selected  */%>
function onKeySizeChange()
{
<%
   if ( !certInfo.isCertificateIssueRequest() )
   {
%>

   var keyAlgo      = utilGetSelectedOptionValue( "<%= WidgetID.KEY_ALGO_TYPE %>" );
   var keySize      = Number( utilGetSelectedOptionValue( "<%= WidgetID.KEY_SIZE %>" ));

   if ( keyAlgo == '<%= Misc.KEY_TYPE_ALGORITHM_ECDSA %>' )
   {
      if ( keySize == <%= Misc.KEY_SIZE_EC_0256 %> )
      {
         utilUpdateAnchorText(
            "<%= WidgetID.KEY_SIZE_HINT %>",
            "" );
      }
      else if ( keySize == <%= Misc.KEY_SIZE_EC_0521 %> )
      {
         utilUpdateAnchorText(
            "<%= WidgetID.KEY_SIZE_HINT %>",
            "" );
      }
      else
      {
         utilUpdateAnchorText(
            "<%= WidgetID.KEY_SIZE_HINT %>",
            "" );
      }
   }
   else
   {
      if ( keySize < <%= Misc.KEY_SIZE_2048 %> )
      {
         utilUpdateAnchorText(
            "<%= WidgetID.KEY_SIZE_HINT %>",
            "<iman:string key = "<%= StringID.HINT_KEY_TOO_SMALL %>"/>" );
      }
      else if ( keySize > <%= Misc.KEY_SIZE_2048 %> )
      {
         utilUpdateAnchorText(
            "<%= WidgetID.KEY_SIZE_HINT %>",
            "<iman:string key = "<%= StringID.HINT_KEY_TOO_LARGE %>"/>" );
      }
      else
      {
         utilUpdateAnchorText(
            "<%= WidgetID.KEY_SIZE_HINT %>",
            "" );
      }
   }
<%
   }
%>
}

<%/* setDefaultKeysize() - this function sets the default Key size based on the Algorithm type selected */%>
function setDefaultKeysize()
{
<%
   if ( !certInfo.isCertificateIssueRequest() )
   {
%>
        var keySize      = utilGetSelectedOptionValue( "<%= WidgetID.KEY_ALGO_TYPE %>" );
        if ( keySize == '<%= Misc.KEY_TYPE_ALGORITHM_ECDSA %>' )
        {
            document.getElementById("<%= WidgetID.KEY_SIZE %>").selectedIndex = 1;       <%/* The Default key size is set to 384 if the Algorithm type is ECDSA  */%>
        }
        else
        {
            document.getElementById("<%= WidgetID.KEY_SIZE %>").selectedIndex = 3;       <%/* The Default key size is set to 2048 if the Algorithm type is RSA   */%>
        }
<%
   }
%>
}

<%/* onKeyAlgoSizeChange() - this function populates the dropdown box for Key Size based on the Algorithm selected */%>
function onKeyAlgoSizeChange()
{
<%
  if ( !certInfo.isCertificateIssueRequest() )
  {
%>
    var keySize      = utilGetSelectedOptionValue( "<%= WidgetID.KEY_ALGO_TYPE %>" );

    if ( keySize == '<%= Misc.KEY_TYPE_ALGORITHM_ECDSA %>' )
    {
       removeOptions( document.Wiz_MainForm[ '<%= WidgetID.KEY_SIZE  %>' ] );
<%

  List keySizesEC = certInfo.getKeyInfo().getSupportedKeySizesForEC(); 

         for ( int i = 0; i < keySizesEC.size(); i++ )
         {
            int keySizeEC = ((Integer)keySizesEC.get( i )).intValue();

%>

                 utilAddOption(
                     "<%= WidgetID.KEY_SIZE %>",
                     "<%=i %>",
                     "<%= keySizeEC %>",
                     "<%= keySizeEC %> <iman:string key = "<%= StringID.LABEL_BITS %>" />");
                  utilSelectOptionByValue( "<%= WidgetID.KEY_SIZE %>", "<%= keySizeEC%>"); 
                  <%} %>
    }
    else
    {

                 removeOptions( document.Wiz_MainForm[ '<%= WidgetID.KEY_SIZE  %>' ] );
<%
         List keySizes = certInfo.getKeyInfo().getSupportedKeySizes();

         for ( int j = 0; j < keySizes.size(); j++ )
         {
            int keySize = ((Integer)keySizes.get( j )).intValue();

                
%>
                 utilAddOption(
                     "<%= WidgetID.KEY_SIZE %>",
                     "<%=j %>",
                     "<%= keySize %>",
                     "<%= keySize %> <iman:string key = "<%= StringID.LABEL_BITS %>" />");
                  utilSelectOptionByValue( "<%= WidgetID.KEY_SIZE %>", "<%= keySize%>");

<%
         }
%>
    }
<%
  }
%>
}

<%/* Depending on which "Type" radio button is selected, uncheck certain checkboxes.  */%>
function uncheckCheckboxes()
{
   var radioBtn;
   var   keyType;

   radioBtn = utilGetSelectedRadioButton( "<%= WidgetID.KEY_TYPE %>" );

   if ( radioBtn == null )
   {
      return;
   }

   <%/* Uncheck all the "Key usage" checkboxes.  */%>
   utilSetElementChecked( "<%= WidgetID.KEY_USAGE_DATA         %>", false );
   utilSetElementChecked( "<%= WidgetID.KEY_USAGE_KEY          %>", false );
   utilSetElementChecked( "<%= WidgetID.KEY_USAGE_DIGITAL      %>", false );
   utilSetElementChecked( "<%= WidgetID.KEY_USAGE_CERT_SIGNING %>", false );
   utilSetElementChecked( "<%= WidgetID.KEY_USAGE_CRL_SIGNING  %>", false );

   keyType = radioBtn.value;

   if ( keyType == '<%= Misc.KEY_TYPE_UNSPECIFIED %>' )
   {
      utilSetElementChecked( "<%= WidgetID.KEY_USAGE_EXTENSION %>", false );
   }
}

<%
   if ( certManager.cmmSupportsExtendedKeyUsage() )
   {
%>
   function saveCheckBoxValue( id )
   {
      utilGetElementByName( id ).storedChecked = utilIsElementChecked( id );
   }

   function saveExtCheckBoxValues()
   {
      saveCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_SERVER_AUTH      %>" );
      saveCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_USER_AUTH        %>" );
      saveCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_CODE_SIGNING     %>" );
      saveCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_EMAIL_PROTECTION %>" );
      saveCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_TIME_STAMPING    %>" );
      saveCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_OCSP_SIGNING     %>" );
      saveCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_ENCRYPTED_FS       %>" );
      saveCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_CERT_TRUST_LIST_SIGNING %>" );
      saveCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_TIME_STAMP_SIGNING      %>" );
      saveCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_SERVER_GATED_CRYPTO     %>" );
      saveCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_CRITICAL         %>" );
   }

   function restoreCheckBoxValue( id )
   {
      utilSetElementChecked( id, utilGetElementByName( id ).storedChecked );
   }

   function restoreExtCheckBoxValues()
   {
      restoreCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_SERVER_AUTH      %>" );
      restoreCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_USER_AUTH        %>" );
      restoreCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_CODE_SIGNING     %>" );
      restoreCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_EMAIL_PROTECTION %>" );
      restoreCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_TIME_STAMPING    %>" );
      restoreCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_OCSP_SIGNING     %>" );
      restoreCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_ENCRYPTED_FS       %>" );
      restoreCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_CERT_TRUST_LIST_SIGNING %>" );
      restoreCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_TIME_STAMP_SIGNING      %>" );
      restoreCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_SERVER_GATED_CRYPTO     %>" );
      restoreCheckBoxValue( "<%= WidgetID.EXT_KEY_USAGE_CRITICAL         %>" );
   }

   function uncheckCheckBoxes_ExtKeyUsage()
   {
      utilSetElementChecked( "<%= WidgetID.EXT_KEY_USAGE_SERVER_AUTH      %>", false );
      utilSetElementChecked( "<%= WidgetID.EXT_KEY_USAGE_USER_AUTH        %>", false );
      utilSetElementChecked( "<%= WidgetID.EXT_KEY_USAGE_CODE_SIGNING     %>", false );
      utilSetElementChecked( "<%= WidgetID.EXT_KEY_USAGE_EMAIL_PROTECTION %>", false );
      utilSetElementChecked( "<%= WidgetID.EXT_KEY_USAGE_TIME_STAMPING    %>", false );
      utilSetElementChecked( "<%= WidgetID.EXT_KEY_USAGE_OCSP_SIGNING     %>", false );
      utilSetElementChecked( "<%= WidgetID.EXT_KEY_USAGE_ENCRYPTED_FS       %>", false );
      utilSetElementChecked( "<%= WidgetID.EXT_KEY_USAGE_CERT_TRUST_LIST_SIGNING %>", false );
      utilSetElementChecked( "<%= WidgetID.EXT_KEY_USAGE_TIME_STAMP_SIGNING      %>", false );
      utilSetElementChecked( "<%= WidgetID.EXT_KEY_USAGE_SERVER_GATED_CRYPTO     %>", false );

      var radioBtn;
      var keyType;

      radioBtn = utilGetSelectedRadioButton( '<%= WidgetID.EXT_KEY_USAGE_TYPE %>' );

      keyType = radioBtn.value;

      if ( keyType == '<%= Misc.EXT_KEY_USAGE_TYPE_ANY %>' )
      {
         utilSetElementChecked( "<%= WidgetID.EXT_KEY_USAGE_CRITICAL %>", false );
      }
   }

   function enableExtKeyUsageCheckboxes( bValue )
   {
      utilEnableControl( "<%= WidgetID.EXT_KEY_USAGE_SERVER_AUTH      %>", bValue );
      utilEnableControl( "<%= WidgetID.EXT_KEY_USAGE_USER_AUTH        %>", bValue );
      utilEnableControl( "<%= WidgetID.EXT_KEY_USAGE_CODE_SIGNING     %>", bValue );
      utilEnableControl( "<%= WidgetID.EXT_KEY_USAGE_EMAIL_PROTECTION %>", bValue );
      utilEnableControl( "<%= WidgetID.EXT_KEY_USAGE_TIME_STAMPING    %>", bValue );
      utilEnableControl( "<%= WidgetID.EXT_KEY_USAGE_OCSP_SIGNING     %>", bValue );
      utilEnableControl( "<%= WidgetID.EXT_KEY_USAGE_ENCRYPTED_FS       %>", bValue );
      utilEnableControl( "<%= WidgetID.EXT_KEY_USAGE_CERT_TRUST_LIST_SIGNING %>", bValue );
      utilEnableControl( "<%= WidgetID.EXT_KEY_USAGE_TIME_STAMP_SIGNING      %>", bValue );
      utilEnableControl( "<%= WidgetID.EXT_KEY_USAGE_SERVER_GATED_CRYPTO     %>", bValue );
   }

   function enableDisableControls_ExtKeyUsage()
   {
      var radioBtn;
      var keyType;

      radioBtn = utilGetSelectedRadioButton( "<%= WidgetID.EXT_KEY_USAGE_TYPE %>" );

      keyType = radioBtn.value;

      if ( keyType == '<%= Misc.EXT_KEY_USAGE_TYPE_SERVER %>' || keyType == '<%= Misc.EXT_KEY_USAGE_TYPE_CLIENT %>' )
      {
         enableExtKeyUsageCheckboxes( false );
      }
      else if ( keyType == '<%= Misc.EXT_KEY_USAGE_TYPE_CUSTOM %>' )
      {
         enableExtKeyUsageCheckboxes( true );
      }
      else if ( keyType == '<%= Misc.EXT_KEY_USAGE_TYPE_ANY %>' )
      {
         enableExtKeyUsageCheckboxes( false );
      }
   }

   function checkCheckboxes_ExtKeyUsage()
   {
      var radioBtn;
      var   keyType;

      radioBtn = utilGetSelectedRadioButton( "<%= WidgetID.EXT_KEY_USAGE_TYPE %>" );

      if ( radioBtn == null )
      {
         return;
      }

      keyType = radioBtn.value;

      <%/* Check the appropriate checkboxes depending on the keyType  */%>

      if ( keyType == '<%= Misc.EXT_KEY_USAGE_TYPE_ANY %>' )
      {
      }
      else if ( keyType == '<%= Misc.EXT_KEY_USAGE_TYPE_CUSTOM %>' )
      {
      }
      else if ( keyType == '<%= Misc.EXT_KEY_USAGE_TYPE_CLIENT %>' )
      {
         utilSetElementChecked( "<%= WidgetID.EXT_KEY_USAGE_USER_AUTH        %>", true );
         utilSetElementChecked( "<%= WidgetID.EXT_KEY_USAGE_EMAIL_PROTECTION %>", true );
      }
      else if ( keyType == '<%= Misc.EXT_KEY_USAGE_TYPE_SERVER %>' )
      {
         utilSetElementChecked( "<%= WidgetID.EXT_KEY_USAGE_SERVER_AUTH %>", true );
      }
      else
      {
         return;
      }
   }

   function preserveRadioGroup (evt)
   {
      this.checked = this.storedChecked;

      var rgb = this.form[this.name];

      if (!rgb.length && rgb.storedChecked)
      {
         rgb.checked = true;
      }
      else
      {
         for (var b = 0; b < rgb.length; b++)
            rgb[b].checked = rgb[b].storedChecked ? true : false;
      }
   }

   function disableRadioGroup (radioGroup)
   {
      if (document.all || document.getElementById)
      {
         if (!radioGroup.length)
            radioGroup.disabled = true;
         else
            for (var b = 0; b < radioGroup.length; b++)
               radioGroup[b].disabled = true;
      }
      else
      {
         if (!radioGroup.length)
         {
            radioGroup.storedChecked = radioGroup.checked;
            radioGroup.oldOnClick = radioGroup.onclick;
            radioGroup.onclick = preserveRadioGroup;
         }
         else
            for (var b = 0; b < radioGroup.length; b++)
            {
               radioGroup[b].storedChecked = radioGroup[b].checked;
               radioGroup[b].oldOnClick = radioGroup[b].onclick;
               radioGroup[b].onclick = preserveRadioGroup;
            }
      }
   }

   function enableRadioGroup (radioGroup)
   {
      if (document.all || document.getElementById)
      {
         if (!radioGroup.length)
            radioGroup.disabled = false;
         else
            for (var b = 0; b < radioGroup.length; b++)
               radioGroup[b].disabled = false;
      }
      else
      {
         if ( !radioGroup.length )
         {
            radioGroup.onclick = radioGroup.oldOnClick;
         }
         else
            for ( var b = 0; b < radioGroup.length; b++ )
            {
               radioGroup[b].onclick = radioGroup[b].oldOnClick;
            }
      }
   }
   function removeOptions(selectbox)
	{
	var i;
	for(i=selectbox.options.length-1;i>=0;i--)
	{
		selectbox.remove(i);
	}
	}	

   function enableDisableExtKeyUsage()
   {
      if ( utilIsElementChecked( "<%= WidgetID.EXT_KEY_USAGE_ENABLED %>" ))
      {
         enableRadioGroup( document.Wiz_MainForm[ '<%= WidgetID.EXT_KEY_USAGE_TYPE %>' ] );
         enableDisableControls_ExtKeyUsage();
         utilEnableControl( "<%= WidgetID.EXT_KEY_USAGE_CRITICAL %>", true );
         restoreExtCheckBoxValues();
      }
      else
      {
         utilEnableControl( "<%= WidgetID.EXT_KEY_USAGE_CRITICAL %>", false );
         disableRadioGroup( document.Wiz_MainForm[ '<%= WidgetID.EXT_KEY_USAGE_TYPE %>' ] );
         enableExtKeyUsageCheckboxes( false );
         saveExtCheckBoxValues();
         uncheckCheckBoxes_ExtKeyUsage();
      }
   }
<%
   }
%>

<%/* -----------------------------------------------------------  */
  /* Validates the selected server information before one of the  */
  /* wizard"s push buttons are handled.                           */
  /* -----------------------------------------------------------  */%>
function isPageValid()
{
   var   sPB;
   var   mergeFile;
   var   radioBtn;

<%
   /* Validate which push button was pressed.  */
%>
   sPB = utilGetPBClicked();

<%
   /* Enable some of the checkboxes.  We need to do this because if a  */
   /* checkbox is checked and disabled its value won"t be sent when  */
   /* the form is submitted.  */

   /* check for bad selections on CA creation.  */
%>

   if ( "<%= UIConst.BUTTON_NEXT_NAME %>" == sPB )
   {
<%
   if ( certInfo.isCertificateAuthority() )
   {
%>

      radioBtn = utilGetSelectedRadioButton( "<%= WidgetID.KEY_TYPE %>" );

      if ( radioBtn == null )
      {
         return false;
      }

      if ( radioBtn.value == '<%= Misc.KEY_TYPE_CUSTOM %>' )
      {
<%
         /* If data encipherment is the only key usage, it is not a valid setting. */
%>
         if ( utilIsElementChecked( "<%= WidgetID.KEY_USAGE_DATA         %>" ) &&
             !utilIsElementChecked( "<%= WidgetID.KEY_USAGE_KEY          %>" ) &&
             !utilIsElementChecked( "<%= WidgetID.KEY_USAGE_DIGITAL      %>" ) &&
             !utilIsElementChecked( "<%= WidgetID.KEY_USAGE_CERT_SIGNING %>" ) &&
             !utilIsElementChecked( "<%= WidgetID.KEY_USAGE_CRL_SIGNING  %>" ))
         {
            alert( "<iman:toScript><iman:string key = "<%= StringID.ERROR_ILLEGAL_KEY_USAGE %>" /></iman:toScript>" );
            return false;
         }
      }
<%
   }
%>

<%
   if ( !certInfo.isSigningCAExternal() )
   {
      /* Enable all the "Key usage" checkboxes.  */
%>
      utilEnableControl( "<%= WidgetID.KEY_USAGE_DATA         %>", true );
      utilEnableControl( "<%= WidgetID.KEY_USAGE_KEY          %>", true );
      utilEnableControl( "<%= WidgetID.KEY_USAGE_DIGITAL      %>", true );
      utilEnableControl( "<%= WidgetID.KEY_USAGE_CERT_SIGNING %>", true );
      utilEnableControl( "<%= WidgetID.KEY_USAGE_CRL_SIGNING  %>", true );
<%
     /* Enable the "Extension" checkbox.  */
%>
      utilEnableControl( "<%= WidgetID.KEY_USAGE_EXTENSION %>", true );
<%
      if ( certManager.cmmSupportsExtendedKeyUsage() )
      {
%>
      enableExtKeyUsageCheckboxes( true );
<%
      }
   }
%>

   }
<%
   /* If we get here, everything validated.  Return true.  */
%>
   return( true );
} <%/* isPageValid */%>

<%
   }
   catch( Exception e )
   {
      D.log( e );
%>
      Exception occured processing WizardPage_CreateCert_Key_js.jsp
<%
   }
%>
