// ********************************************************************
// %name:  utilScripts.js %
// %version:  idc_nmas#11 %
// %date_modified:  Tue Jul 31 11:20:41 2007 %
// Copyright (c) 2005 Novell, Inc. All Rights Reserved.
// THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL PROPRIETARY
// AND TRADE SECRET INFORMATION OF NOVELL, INC. ACCESS TO THIS WORK IS
// RESTRICTED TO (I) NOVELL, INC. EMPLOYEES WHO HAVE A NEED TO KNOW HOW
// TO PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS AND (II)
// ENTITIES OTHER THAN NOVELL, INC. WHO HAVE ENTERED INTO APPROPRIATE
// LICENSE AGREEMENTS. NO PART OF THIS WORK MAY BE USED, PRACTICED,
// PERFORMED COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED,
// CONDENSED, EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED
// OR ADAPTED WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE
// OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE
// PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.
// ********************************************************************


// Global variables.


function utilIsValidIPAddress(
   address )
{
   // Check first segment
   var frontIndex = 0;
   var backIndex   = address.indexOf( "." );

   if ( backIndex == -1 )
   {
      return false;
   }

   if ( !utilIsValidNumberRange( address.substring( frontIndex, backIndex ), 0, 255 ))
   {
      return false;
   }

   // Check second segment
   frontIndex = backIndex + 1;
   backIndex    = address.indexOf( ".", frontIndex );

   if ( backIndex == -1 )
   {
      return false;
   }

   if ( !utilIsValidNumberRange( address.substring( frontIndex, backIndex ), 0, 255 ))
   {
      return false;
   }

   // Check third segment
   frontIndex = backIndex + 1;
   backIndex   = address.indexOf( ".", frontIndex );

   if ( backIndex == -1 )
   {
      return false;
   }

   if ( !utilIsValidNumberRange( address.substring( frontIndex, backIndex ), 0, 255 ))
   {
      return false;
   }

   // Check fourth segment and ensure that it is the last
   frontIndex = backIndex+1;
   backIndex    = address.indexOf( ".", frontIndex );

   if ( backIndex != -1 )
   {
      return false;
   }

   if ( !utilIsValidNumberRange( address.substring( frontIndex ), 0, 255 ))
   {
      return false;
   }

   // If we have arrived here then the IP address is in a valid format
   return true;
}

function utilIsValidNumberRange( num, min, max )
{
   // Check for numbers only

   if ( isNaN( parseInt( num )))
   {
      return false;
   }

   // Check range of numbers
   if ( num >= min && num <= max )
   {
      return true;
   }

   return false;
}

function utilIsValidPort( portNum )
{
   if ( !utilIsValidNumberRange( portNum, 0, 65535 ))
   {
      return false;
   }

   return true;
}

/*--------------------------------------------------------------- */
/* Return a reference to an element given its name.               */
/*--------------------------------------------------------------- */
function utilGetElementByName( elementName )
{
   var elementRef = null;

   if ( document.getElementById )
   {
      // If this is a DOM-compliant browser then use the DOM method
      elementRef = document.getElementById( elementName );
   }

   if ( null == elementRef && document.all )
   {
      // Otherwise, if the IE API is supported then use the all[] array
      // to find the element
      elementRef = document.all[ elementName ];
   }

   if ( null == elementRef && document.layers )
   {
      // Else if the Netscape API is supported then use the layers[]
      // array to get the element
      elementRef = document.layers[ elementName ];
   }

   return( elementRef );
}

function utilGetRadioButtonGroup( groupName )
{
   return eval( "document.forms[0].elements['" + groupName + "']" );
}

function utilGetRadioElementByName( elementName, index )
{
   var elementRef = eval("document.forms[0].elements['"+elementName+"']["+index+"]");;
   return( elementRef );
}

function utilGetSelectedRadioButton( elementName )
{
   groupLen = eval("document.forms[0].elements['"+elementName+"'].length");

   for (i=0; i<groupLen; i++)
   {
      var element = eval('document.forms[0].elements["'+elementName+'"]['+i+']');

      if ( element != null && element.checked )
      {
         return element;
      }
   }

   return null;
}

function utilSetSelectedRadioButtonByValue( elementName, value )
{
   groupLen = eval("document.forms[0].elements['"+elementName+"'].length");

   for (i=0; i<groupLen; i++)
   {
      var element = eval('document.forms[0].elements["'+elementName+'"]['+i+']');

      if ( element != null && element.value == value )
      {
         element.checked = true;
         return;
      }
   }
}

function utilEnableRadioButton( elementName, enabled )
{
   groupLen = eval("document.forms[0].elements['"+elementName+"'].length");

   for (i=0; i<groupLen; i++)
   {
      var element = eval('document.forms[0].elements["'+elementName+'"]['+i+']');

      if ( element != null )
      {
         element.disabled = enabled ? false : true;
      }
   }
}

function utilGetElementValue( elementName )
{
   var element = utilGetElementByName( elementName );

   if ( element == null )
   {
      alert( "Element " + elementName + " cannot be found" );
      return "";
   }

   if ( element.type == "radio" )
   {
      return utilGetSelectedRadioButton( elementName ).value;
   }

   return element.value;
}

function utilSetElementValue( elementName, elementValue )
{
   var element = utilGetElementByName( elementName );

   if ( element == null )
   {
      alert( "Element " + elementName + " cannot be found.  Value '" + elementValue + "' not set" );
      return;
   }

   element.value = elementValue;
}

function utilIsElementValueEmpty( elementName )
{
   var element = utilGetElementByName( elementName );

   if ( element )
   {
      return element.value == "";
   }

   return false;
}

function utilClearElementValue( elementName )
{
   utilSetElementValue( elementName, "" );
}

function utilIsElementChecked( elementName )
{
   var element = utilGetElementByName( elementName );

   if ( element )
   {
      return element.checked;
   }

   return false;
}

function utilSetElementChecked( elementName, value )
{
   var element = utilGetElementByName( elementName );

   if ( element )
   {
      element.checked = value;
   }
}

function utilSetElementFocus( elementName )
{
   var element = utilGetElementByName( elementName );

   if ( element )
   {
      element.focus();
   }
}
function utilSetPageFocus()
{
   var element = nidsGetElementByName( "activePage" );
   if ( null != element )
   {
      element.focus();
   }
   else
   {
      element = nidsGetElementByName( "activeChapter" );
      if ( null != element )
      {
         element.focus();
      }
   }
}
function utilIsOptionSelected( elementName, optionNumber )
{
  var element = utilGetElementByName( elementName );

   if ( element )
   {
      return element.options[ optionNumber ].selected;
   }

   return false;
}

function utilIsOptionSelectedByValue( elementName, targetValue )
{
   var element = utilGetElementByName( elementName );

   if ( element )
   {
      for ( var i = 0; i < element.options.length; i++ )
      {
         if ( element.options[ i ].value == targetValue )
         {
            return element.options[ i ].selected;
         }
      }
   }

   return false;
}

function utilSelectOptionByValue( elementName, targetValue )
{
   var element = utilGetElementByName( elementName );

   if ( element )
   {
      for ( var i = 0; i < element.options.length; i++ )
      {
         if ( element.options[ i ].value == targetValue )
         {
            element.options[ i ].selected = true;
         }
      }
   }
}

function utilSelectOption( elementName, optionNumber )
{
   var element = utilGetElementByName( elementName );

   if ( element )
   {
      element.options[ optionNumber ].selected = true;
   }
}

function utilGetOptionCount( elementName )
{
   var element = utilGetElementByName( elementName );

   if ( element )
   {
      return element.options.length;
   }

   return 0;
}

function utilGetOptionValue( elementName, optionNumber )
{
   var element = utilGetElementByName( elementName );

   if ( element && optionNumber < element.options.length )
   {
      return element.options[ optionNumber ].value;
   }

   return null;
}

function utilGetSelectedOptionValue( elementName )
{
   var element = utilGetElementByName( elementName );

   if ( element )
   {
      for ( var i = 0; i < element.options.length; i++ )
      {
         if ( element.options[ i ].selected )
         {
            return element.options[ i ].value;
         }
      }
   }

   return "";
}

function utilEnableControl( elementName, enabled )
{
   var element = utilGetElementByName( elementName );

   if ( element )
   {
      if ( element.type == "radio" )
      {
         utilEnableRadioButton( elementName, enabled );
      }
      else
      {
         element.disabled = enabled ? false : true;
      }
   }
}

function utilIsElementEnabled( elementName )
{
   var element = utilGetElementByName( elementName );

   if ( element )
   {
      return !element.disabled;
   }

   return false;
}

function utilAddOption( elementName, optionNumber, value, text )
{
   var element = utilGetElementByName( elementName );

   if ( element )
   {
      element.options[ element.options.length ] = new Option( "", "" );

      for ( var i = element.options.length - 1; i > optionNumber; i-- )
      {
         element.options[ i ].text  = element.options[ i - 1 ].text;
         element.options[ i ].value = element.options[ i - 1 ].value;
      }

      element.options[ optionNumber ] = new Option( text, value );
   }
}

function utilRemoveOption( elementName, optionNumber )
{
   var element = utilGetElementByName( elementName );

   if ( element && optionNumber < element.options.length )
   {
      element.options[ optionNumber ] = null;
   }
}

function utilSubmitDocumentForm( validateForm )
{
   var saveButtons = oldButtons;

   utilDisableButtons();

   if ( validateForm && typeof isPageValid == "function" && !isPageValid() )
   {
      return;
   }

   try
   {
      document.forms[0].submit();
   }
   catch( e )
   {
      alert( e );
      utilSetFooterButtons( saveButtons );
   }
}
/*--------------------------------------------------------------- */
/* Format a la printf().                                          */
/*--------------------------------------------------------------- */
function utilFormatString( str, arg1 )
{
   // skip the 0th argument
   for ( var i = 1; i < arguments.length; i++ )
   {
      var toReplace = "{" + eval( i - 1 ) + "}";
      var start = str.indexOf( toReplace );
      if ( start != -1 )
      {
         var before = str.substring( 0, start );
         var insert = arguments[ i ];
         var after  = str.substring( start + toReplace.length, str.length );
         var result = before + insert + after;
      }
      else
      {
         break;
      }
   }
   return result;
}

function utilIsValidDomainFormat(
   domainString )
{
   var status = true;

   // Look for illegal characters
   if ( domainString.indexOf( "/" ) != -1 )
   {
      status = false;
   }
   else if ( domainString.indexOf( ":" ) != -1 )
   {
      status = false;
   }
   else if ( domainString.indexOf( " " ) != -1 )
   {
      status = false;
   }

   return status;
}

// --------------------------------------------------------------- //
// Scans an element's ancestry to determine if anything containing //
// the element is hidden.                                          //
// --------------------------------------------------------------- //
function utilIsAncestryVisible(
   eWidget)   // The element to check for ancestry visibility.
{
   var   computedStyle;
   var   eParent;

   eParent = eWidget.parentElement;
   if (null == eParent)
   {
      return true;
   } // if


   // Get the computed style for the widget's parent.
   if (eParent.currentStyle)
       computedStyle = eParent.currentStyle;
   else computedStyle = window.getComputedStyle( eParent, '' );


//alert( eParent.nodeName + ': visibility: ' + computedStyle.visibility );


   // Is this widget hidden?
   if ('hidden' == computedStyle.visibility)
   {
      // Yes!  Return false.
      // debugOut_Always( eParent.id + ":  ancestry hidden" );
      return( false );
   } // if

   else if ('visible' == computedStyle.visibility)
   {
      return true;
   } // else if

   else if ('inherit' == computedStyle.visibility)
   {
      // Since the visibility of this element is 'inherit' we need to
      // check the element's parent.  Recursively call ourselves to
      // see if our parent's ancestory is visible.
      return utilIsAncestryVisible( eParent );
   } // else if

   else
   {
      // We should never get here.
      alert( 'In utilIsAncestryVisible(), unknown value for visibility: ' + computedStyle.visibility );
   } // else
} // isAncestryVisible

function utilShowHideAnElement(
   element,           //
   show,              //
   considerAncestry ) //
{
   considerAncestry = (considerAncestry && (true  == considerAncestry));
   if ((null != element) &&
      ((!considerAncestry) || utilIsAncestryVisible( element )))
   {
      // debugOut_Always( element.id + ":  " + (show ? "show" : "hide") );
      if (show)
      {
         if ( !considerAncestry )
            element.style.visibility = "visible";
         else
            element.style.visibility = 'inherit';
      }
      else element.style.visibility = "hidden";
   } // if
} // showHideAnElement

function utilIsElementContainedByDiv( element, divName )
{
   if ( element.name == divName || element.id == divName )
   {
      return true;
   }

   if ( null == element.parentNode )
   {
      return false;
   }

   return utilIsElementContainedByDiv( element.parentNode, divName );
}

function utilShowHideWindowedWidgets(
   show,   			// true -> Show them.  false -> Hide them.
   arIgnoreThese)	// elements in this div will not be hidden/shown
{
   var   ae;
   var   c;
   var   i, k;

   // Scan the SELECT widgets...
   ae = document.getElementsByTagName( "SELECT" );
   c  = ae.length;
   for (i = 0; i < c; i += 1)
   {
       var bIgnore = false;

       if ( null != arIgnoreThese )
       {
          bIgnore = utilIsElementContainedByDiv( ae[ i ], arIgnoreThese );
       }

       if (!bIgnore)
       {
        // hide this element
        utilShowHideAnElement(
           ae[i],   // The element to show/hide.
           show,   // true -> Show.  false -> Hide.
           true );   // true -> Consider ancestry's visibility.
     }
   } // for


   // Do we want to consider hiding the other INPUT widgets?  The only
   // one that causes a problem is the select control.
} // showHideWindowedWidgets


function utilShowElement(
   elementName )
{
   var element = utilGetElementByName( elementName );

   if ( null != element )
   {
      if ( element.style.display == "none" )
      {
         element.style.display = "block";
      }
   }
}

function utilHideElement(
   elementName )
{
   var element = utilGetElementByName( elementName );

   if ( null != element )
   {
      if ( element.style.display != "none" )
      {
         element.style.display = "none";
      }
   }
}

/*--------------------------------------------------------------- */
/* Functions to move options between two <select>'s               */
/*--------------------------------------------------------------- */

      function utilMoveOption(elementFrom, elementTo, bFromIsInteresting, elementList, strWarnOnFromEmpty)
      {	// If we have a warning string to display if the "elementFrom" control would
        // be emptied by this operation, then display it and do not empty he control.
         if (null != strWarnOnFromEmpty)
         {
           if (1 == elementFrom.options.length)
           {	// There is only one element in the "from" control.
              alert(strWarnOnFromEmpty);
              return;
           }
         }
         var index = elementFrom.selectedIndex;
         if(index!=-1)
         {
            var option = elementFrom.options[index];
            elementFrom.options[index] = null;

            var length = elementTo.options.length;
            elementTo.options[length] = new Option(option.text, option.value);
         }
         if (bFromIsInteresting)
         {
           utilUpdateAfterMoveOption(elementFrom, elementList);
         }
         else
         {
           utilUpdateAfterMoveOption(elementTo, elementList);
         }
      }

function utilUpdateAfterMoveOption(element, elementList)
{
   var list = new Array();
   var options = element.options;

   for ( var i = 0; i < options.length; i++ )
   {
      list[list.length] = options[i].value;
   }
   elementList.value = pack(list);
}

function utilMoveOptionUp(sel, elementList)
{
   var index = sel.selectedIndex;

   if ( index >= 0 && index > 0 )
   {
      var tempVal = sel.options[index].value;
      var tempTxt = sel.options[index].text;

      sel.options[index].value = sel.options[index-1].value;
      sel.options[index].text = sel.options[index-1].text;

      sel.options[index-1].value = tempVal;
      sel.options[index-1].text = tempTxt;

      sel.selectedIndex = index-1;
      utilUpdateAfterMoveOption(sel, elementList);
   }
}

function utilMoveOptionDown(sel, elementList)
{
   var index = sel.selectedIndex;

   if ( index >= 0 && index < sel.length - 1 )
   {
      var tempVal = sel.options[index].value;
      var tempTxt = sel.options[index].text;

      sel.options[index].value = sel.options[index+1].value;
      sel.options[index].text = sel.options[index+1].text;

      sel.options[index+1].value = tempVal;
      sel.options[index+1].text = tempTxt;

      sel.selectedIndex = index+1;
      utilUpdateAfterMoveOption(sel, elementList);
   }
}

function utilEditObject( distinguishedName )
{
   parent.disableButtons();

   var dnArray = new Array();

   dnArray[ 0 ] = distinguishedName;

   document.forms[0].DNList.value     = pack( dnArray );
   document.forms[0].NextAction.value = "EditObject";
   document.forms[0].submit();
}

function handleFrameAction( strAction )
{
   var result = false;

   if ( strAction == "nextButton"   ||
        strAction == "finishButton" ||
        strAction == "backButton"   ||
        strAction == "closeButton" )
   {
      if ( typeof isPageValid == "function" && !isPageValid() )
      {
         return true;
      }

      parent.disableButtons();

      document.forms[0].Frame_Hidden_PB_Navigation.value = strAction;
      document.forms[0].NextAction.value                 = "HandleNavigation";
      document.forms[0].submit();

      result = true;
   }
   else if ( strAction == "backButton2" )
   {
      parent.disableButtons();
      history.go(-1);

      result = true;
   }

   return result;
}

var oldButtons = null;

window.nextButton   = 1;
window.backButton   = 2;
window.applyButton  = 4;
window.cancelButton = 8;
window.finishButton = 16;
window.closeButton  = 32;
window.okButton     = 64;

window.nextDisabledButton   = 128;
window.backDisabledButton   = 256;
window.applyDisabledButton  = 512;
window.cancelDisabledButton = 1024;
window.finishDisabledButton = 2048;
window.closeDisabledButton  = 4096;
window.okDisabledButton     = 8192;

function utilSetFooterButtons(buttons)
{
   if ( oldButtons != buttons )
   {
      utilSetButton( "applyButton",          buttons & applyButton  );
      utilSetButton( "backButton",           buttons & backButton   );
      utilSetButton( "nextButton",           buttons & nextButton   );
      utilSetButton( "cancelButton",         buttons & cancelButton );
      utilSetButton( "finishButton",         buttons & finishButton );
      utilSetButton( "closeButton",          buttons & closeButton  );
      utilSetButton( "okButton",             buttons & okButton     );

      utilSetButton( "applyButtonDisabled",  buttons & applyDisabledButton  );
      utilSetButton( "backButtonDisabled",   buttons & backDisabledButton   );
      utilSetButton( "nextButtonDisabled",   buttons & nextDisabledButton   );
      utilSetButton( "cancelButtonDisabled", buttons & cancelDisabledButton );
      utilSetButton( "finishButtonDisabled", buttons & finishDisabledButton );
      utilSetButton( "closeButtonDisabled",  buttons & closeDisabledButton  );
      utilSetButton( "okButtonDisabled",     buttons & okDisabledButton     );

      oldButtons = buttons;
   }
}

function utilSetDialogButtons(dialogId,buttons)
{
   if ( eval( dialogId + "_buttonState" ) != buttons )
   {
      utilSetButton( dialogId + "_applyButton",          buttons & applyButton  );
      utilSetButton( dialogId + "_backButton",           buttons & backButton   );
      utilSetButton( dialogId + "_nextButton",           buttons & nextButton   );
      utilSetButton( dialogId + "_cancelButton",         buttons & cancelButton );
      utilSetButton( dialogId + "_finishButton",         buttons & finishButton );
      utilSetButton( dialogId + "_closeButton",          buttons & closeButton  );
      utilSetButton( dialogId + "_okButton",             buttons & okButton     );
      utilSetButton( dialogId + "_applyButtonDisabled",  buttons & applyDisabledButton  );
      utilSetButton( dialogId + "_backButtonDisabled",   buttons & backDisabledButton   );
      utilSetButton( dialogId + "_nextButtonDisabled",   buttons & nextDisabledButton   );
      utilSetButton( dialogId + "_cancelButtonDisabled", buttons & cancelDisabledButton );
      utilSetButton( dialogId + "_finishButtonDisabled", buttons & finishDisabledButton );
      utilSetButton( dialogId + "_closeButtonDisabled",  buttons & closeDisabledButton  );
      utilSetButton( dialogId + "_okButtonDisabled",     buttons & okDisabledButton     );

      eval( dialogId + "_buttonState = buttons;" );
   }
}

function utilSetButton( buttonName, bDisplay )
{
   var button = utilGetElementByName( buttonName );

   if ( null != button )
   {
      button.style.display = ( bDisplay > 0 ? "inline" : "none" );
   }
}

function utilDisableButtons()
{
   utilSetFooterButtons(( oldButtons << 7 ) | ( oldButtons & 16256 ));
}

function utilDisableDialogButtons( dialogId )
{
   var dlgButtons = eval( dialogId + "_buttonState" );

   utilSetDialogButtons( dialogId, ( dlgButtons << 7 ) | ( dlgButtons & 16256 ));
}

function utilDoKeyAction( strAction )
{
   if (window.event.keyCode == 13 || window.event.keyCode == 32)
   {
      utilDoAction( strAction );
   }
}

function utilDoAction( strAction )
{
   if ( typeof handleAction == "function" && handleAction( strAction ))
   {
      return;
   }

   utilSetElementValue( "Frame_Hidden_PB_Navigation", strAction );

   if ( strAction == "nextButton"   ||
        strAction == "backButton"   ||
        strAction == "finishButton" ||
        strAction == "applyButton"  ||
        strAction == "closeButton"  ||
        strAction == "okButton" )
   {
      if ( typeof isPageValid == "function" && !isPageValid() )
      {
         return true;
      }
   }

   utilSetElementValue( "Frame_Hidden_PB_Navigation", strAction );
   utilSetElementValue( "TaskAction", "Navigate" );

   utilSubmitDocumentForm();
}

function utilGetPBClicked()
{
   return utilGetElementValue( "Frame_Hidden_PB_Navigation" );
}

function utilMoveToUILevel( level )
{
   utilSetElementValue( "Frame_Hidden_PB_Navigation", "breadCrumb" );
   utilSetElementValue( "TaskAction", "Navigate" );
   utilSetElementValue( "TaskParam", level );

   utilSubmitDocumentForm();
}

function utilPositionFooterDiv( headerDivID, bodyDivID, footerDivID )
{
   var headerDiv = utilGetElementByName( headerDivID );
   var bodyDiv   = utilGetElementByName( bodyDivID   );
   var footerDiv = utilGetElementByName( footerDivID );

   var screenHeight;
   var screenWidth;

   //get the height and width
   if ( window.innerHeight )
   {
      screenHeight = window.innerHeight;
      screenWidth  = window.innerWidth;
   }
   else if ( document.documentElement && document.documentElement.clientHeight )
   {
      screenHeight = document.documentElement.clientHeight;
      screenWidth  = document.documentElement.clientWidth;
   }
   else if ( document.body && document.body.clientHeight )
   {
      screenHeight = document.body.clientHeight;
      screenWidth  = document.body.clientWidth;
   }
   else
   {
      screenHeight = 0;
      screenWidth = 0;
   }

   var footerHeight = parseInt( footerDiv.style.height, 10 );

   yPos = screenHeight - footerHeight;

   if ( yPos < 0 )
   {
      yPos = 0;
   }

//   var bodyTop  = parseInt( bodyDiv.style.top,  10 );
   var bodyTop  = bodyDiv.offsetTop;
//   var bodyLeft = parseInt( bodyDiv.style.left, 10 );
   var bodyLeft = bodyDiv.offsetLeft;

   if ( isNaN( bodyTop ))
   {
      bodyTop  = bodyDiv.pageY;
      bodyLeft = bodyDiv.pageX;
   }

   if ( isNaN( bodyTop ))
   {
      // See if we can get the header height
      var headerHeight = headerDiv.offsetHeight;

      if ( isNaN( headerHeight ))
      {
         bodyTop = 0;
      }
      else
      {
         bodyTop = headerHeight;
      }
   }

   if ( isNaN( bodyLeft ))
   {
      bodyLeft = 0;
   }

   height = screenHeight - footerHeight - bodyTop - 5;
   width  = screenWidth  - 25;

   headerDiv.style.width = width  + "px";

   bodyDiv.style.height  = height + "px";
   bodyDiv.style.width   = width  + "px";

   footerDiv.style.top   = yPos  + "px";
   footerDiv.style.width = width + "px";
}

function utilShowSubMenu(
   event,
   subMenuName )
{
   var element = utilGetElementByName( subMenuName );

   if ( null != element )
   {
      if ( element.style.display == "none" )
      {
         var source = (event.target ? event.target : event.srcElement);

         element.style.left = source.offsetLeft;

         element.style.display = "block";
      }
   }
}

function utilHideSubMenu(
   subMenuName )
{
   var element = utilGetElementByName( subMenuName );

   if ( null != element )
   {
      if ( element.style.display != "none" )
      {
         element.style.display = "none";
      }
   }
}

function utilShowHelp( helpURL )
{
   window.open(
      helpURL,
      "",
      (
         "toolbar=no,location=no," +
         "directories=no,menubar=no," +
         "scrollbars=yes,resizable=yes," +
         "width=500,height=500"
      )
   ).focus();
}

function utilUpdateWizardStepText( stepText )
{
   utilGetElementByName("WizardStepText").innerHTML = stepText;
}

function utilUpdateWizardSubHeader( subTitle )
{
   utilGetElementByName("WizardSubHeader").innerHTML = subTitle;
}

function utilUpdateWizardHeader( title )
{
   utilGetElementByName("WizardHeader").innerHTML = title;
}

function utilShowHideDiv( divId, isVisible )
{
   var found = false;
   var element = null;

   element = utilGetElementByName( divId );

   if ( element )
   {
      found = true;
      if ( element.style )
      {
         element.style.visibility = "hidden";
         if ( isVisible )
         {
            element.style.visibility = "visible";
         }
      }
      else
      {
         element.visibility = "hide";
         if ( isVisible )
         {
            element.visibility = "show";
         }
      }
   }

   if ( found == false )
   {
      alert( 'In showHideDiv(), unable to find divId: ' + divId );
   }
}

// ------------------------------------------------------- //
// Update the text in the text node for the given element. //
// ------------------------------------------------------- //
function utilUpdateElementsTextNode(
   element,   // The Element whose text Node is to be updated.
   newText)   // The text to update the Node with.
{
   var   found;
   var   i;
   var kids;
   var   numKids;


   if (null == element)
   {
      return;
   } // if


   // Find the text node for this element.
   kids    = element.childNodes;
   numKids = kids.length;
   found   = false;
   for (i = 0; ((i < numKids) && (!found)); i += 1)
   {
      // Is this child a text node?
      if (3 == kids[i].nodeType)
      {
         // Yes!  Replace its text with the new text.
         kids[i].data = newText;
         found        = true;
      } // if
   } // for


   // Did we find a text node?
   if (!found)
   {
      var   textNode;


      // No!  Create one and add it to the element.
      textNode = element.ownerDocument.createTextNode( newText );
      element.appendChild( textNode );
   } // if
} // updateElementsTextNode



// ---------------------------------------- //
// Updates the text contained in an anchor. //
// ---------------------------------------- //
function utilUpdateAnchorText(
   anchorId,   // The ID of the anchor whose text is to be updated.
   newText)   // The text to update the anchor with.
{
   utilUpdateTextNode( anchorId, newText );
} // updateAnchorText



// ------------------------------------------------------- //
// Update the text in the text node for the given element.
// ------------------------------------------------------- //
function utilUpdateTextNode(
   elementId,   // The ID of the text Node whose text is to be updated.
   newText)   // The text to update the text Node with.
{
   var   element;


   // Find the element that whose text node we should update.
   element = utilGetElementByName( elementId );
   utilUpdateElementsTextNode( element, newText );
} // updateTextNode

function utilHasString( sValue )
{
   return( ( null != sValue ) && ( 0 < sValue.length ) );
}

function utilActivateDialog( id )
{
   if ( id == null || id.length == 0 )
   {
      return false;
   }

   var dlgObject = utilGetElementByName( id );

   if ( null != dlgObject )
   {
      utilShowHideWindowedWidgets( false, id );

      dlgObject.style.display = "block";

      positionIt( id );
   }
}

function utilDeactivateDialog( id )
{
   if ( id == null || id.length == 0 )
   {
      return false;
   }

   var dlgObject = utilGetElementByName( id );

   if ( null != dlgObject )
   {
      dlgObject.style.display = "none";

      utilShowHideWindowedWidgets( true, id );
   }

   window.clearTimeout( eval( id + "_timeoutID" ));

   eval( id + "_timeoutID = 0;" );
}

function utilSetDialogTitle( id, title )
{
   var element = utilGetElementByName( id + "_title" );

   if ( null != element )
   {
      element.innerHTML = title;
   }
}

function positionIt( id )
{
   if ( document.getElementById )
   {
      // Get a reference to divTest and measure its width and height.
      var div = document.getElementById( id );

      if ( div.style.display == "block" )
      {
         var divWidth = div.offsetWidth ? div.offsetWidth : div.style.width ? parseInt( div.style.width ) : 0;
         var divHeight = div.offsetHeight ? div.offsetHeight :  div.style.height ? parseInt( div.style.height ) : 0;

         // Calculating setX and setX so the div will be centered in the viewport.
         var setX = ( getViewportWidth () - divWidth  ) / 2;
         var setY = ( getViewportHeight() - divHeight ) / 2;

         // If setX or setY have become smaller than 0, make them 0.
         if ( setX < 0 ) setX = 0;
         if ( setY < 0 ) setY = 0;

         // Position the div in the center of the page and make it visible.
         div.style.left = setX + getViewportScrollX() + "px";
         div.style.top  = setY + getOffsetTopY() + "px";

         if ( eval( id + "_timeoutID" ) == 0 )
         {
            var func;

            func  = id + "_timeoutID = setInterval( 'positionIt(";
            func += '"' + id + '"';
            func += " )', 1000 );";

            eval ( func );
         }
      }
   }
}

function getViewportWidth()
{
   var width = 0;
   var bodyDiv = document.getElementById( "bodyDiv" );

   if ( null != bodyDiv )
   {
      width = bodyDiv.offsetWidth ? bodyDiv.offsetWidth : bodyDiv.style.width ? parseInt( bodyDiv.style.width ) : 0;
   }
   else if ( document.documentElement && document.documentElement.clientWidth )
   {
      width = document.documentElement.clientWidth;
   }
   else if ( document.body && document.body.clientWidth )
   {
      width = document.body.clientWidth;
   }
   else if ( window.innerWidth )
   {
      width = window.innerWidth - 18;
   }
   return width;
}

function getViewportHeight()
{
   var height = 0;

   var bodyDiv = document.getElementById( "bodyDiv" );

   if ( null != bodyDiv )
   {
      height = bodyDiv.offsetHeight ? bodyDiv.offsetHeight :  bodyDiv.style.height ? parseInt( bodyDiv.style.height ) : 0;
   }
   else if ( document.documentElement && document.documentElement.clientHeight )
   {
      height = document.documentElement.clientHeight;
   }
   else if ( document.body && document.body.clientHeight )
   {
      height = document.body.clientHeight;
   }
   else if ( window.innerHeight )
   {
      height = window.innerHeight - 18;
   }

   return height;
}

function getViewportScrollX()
{
   var scrollX = 0;

   if ( document.documentElement && document.documentElement.scrollLeft )
   {
      scrollX = document.documentElement.scrollLeft;
   }
   else if ( document.body && document.body.scrollLeft )
   {
      scrollX = document.body.scrollLeft;
   }
   else if ( window.pageXOffset )
   {
      scrollX = window.pageXOffset;
   }
   else if ( window.scrollX )
   {
      scrollX = window.scrollX;
   }

   return scrollX;
}

function isIE()
{
   return (navigator.appName.indexOf("Microsoft") !=-1);
}

function getOffsetTopY( div )
{
   var scrollY = 0;

   var bodyDiv = document.getElementById( "bodyDiv" );

   if ( null != bodyDiv )
   {
      if ( isIE() )
      {
         if ( bodyDiv.scrollTop )
         {
            scrollY = bodyDiv.scrollTop;
         }
      }
      else if ( bodyDiv.offsetTop )
      {
         scrollY = bodyDiv.offsetTop;
      }
   }
   else if ( null != div && null != div.parentNode )
   {
      var element = div.parentNode;

      if ( element.offsetTop )
      {
         scrollY = element.offsetTop;
      }
   }
   else
   {
      if ( document.documentElement && document.documentElement.offsetTop )
      {
         scrollY = document.documentElement.offsetTop;
      }
      else if ( document.body && document.body.offsetTop )
      {
         scrollY = document.body.offsetTop;
      }
      else if ( window.pageYOffset )
      {
         scrollY = window.pageYOffset;
      }
      else if ( window.scrollY )
      {
         scrollY = window.scrollY;
      }
   }

   return scrollY;
}

function getViewportScrollY()
{
   var scrollY = 0;

   var bodyDiv = document.getElementById( "bodyDiv" );

   if ( null != bodyDiv )
   {
      if ( bodyDiv.scrollTop )
      {
         scrollY = bodyDiv.scrollTop;
      }
   }
   else
   {
      if ( document.documentElement && document.documentElement.scrollTop )
      {
         scrollY = document.documentElement.scrollTop;
      }
      else if ( document.body && document.body.scrollTop )
      {
         scrollY = document.body.scrollTop;
      }
      else if ( window.pageYOffset )
      {
         scrollY = window.pageYOffset;
      }
      else if ( window.scrollY )
      {
         scrollY = window.scrollY;
      }
   }

   return scrollY;
}

function utilSelectChapter( index )
{
   utilSetElementValue   ( 'TaskAction', 'SelectChapter' );
   utilSetElementValue   ( 'TaskParam',  index           );
   utilSubmitDocumentForm( false                         );
}

function utilShowPage( index )
{
   utilSetElementValue   ( 'TaskAction', 'SelectPage' );
   utilSetElementValue   ( 'TaskParam',  index        );
   utilSubmitDocumentForm( false                      );
}
                          // * * * * * * //
                          // End of File //
                          // * * * * * * //



